package types

import (
	"gorm.io/gorm"
)

type Account struct {
	ID      int64  `json:"id"`
	User    int64  `json:"user"`
	Session []byte `json:"session"`

	Name  string `json:"name"`
	Corp  string `json:"corp"`
	Level int    `json:"level"`

	Eat        bool   `json:"eat"`
	Eat200     bool   `json:"eat_200"`
	EatCommand string `json:"eat_command" gorm:"default:/eat"`
	EatChance  int    `json:"eat_chance" gorm:"default:100"`

	Levelup      bool `json:"levelup"`
	LevelupSkill bool `json:"levelup_skill"`

	Pin       bool    `json:"pin"`
	PinChat   int64   `json:"pin_chat"`
	PinDelay  float64 `json:"pin_delay"  gorm:"default:5"`
	PinChance int     `json:"pin_chance"  gorm:"default:100"`

	Report               bool    `json:"report"`
	ReportChat           int64   `json:"report_chat"`
	ReportChatAccessHash int64   `json:"report_chat_access_hash"`
	ReportDelay          float64 `json:"report_delay"  gorm:"default:5"`
	ReportChance         int     `json:"report_chance"  gorm:"default:100"`

	Mob       bool    `json:"mob"`
	MobDelay  float64 `json:"mob_delay"  gorm:"default:10"`
	MobChance int     `json:"mob_chance"  gorm:"default:30"`

	Sleep      bool `json:"sleep"`
	SleepHotel bool `json:"sleep_hotel"  gorm:"default:true"`

	Stock     bool   `json:"stock"`
	StockCorp string `json:"stock_corp"`

	Shark      bool    `json:"shark"`
	SharkDelay float64 `json:"shark_delay" gorm:"default:10"`
	SharkTeam  bool    `json:"shark_team"`

	Motivation        bool   `json:"motivation"  gorm:"default:true"`
	MotivationKD      bool   `json:"motivation_kd"`
	MotivationCommand string `json:"motivation_command"  gorm:"default:/harvest"`

	gorm.Model
}
