// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// AccountCancelPasswordEmailRequest represents TL type `account.cancelPasswordEmail#c1cbd5b6`.
// Cancel the code that was sent to verify an email to use as 2FA recovery method¹.
//
// Links:
//  1) https://core.telegram.org/api/srp
//
// See https://core.telegram.org/method/account.cancelPasswordEmail for reference.
type AccountCancelPasswordEmailRequest struct {
}

// AccountCancelPasswordEmailRequestTypeID is TL type id of AccountCancelPasswordEmailRequest.
const AccountCancelPasswordEmailRequestTypeID = 0xc1cbd5b6

// Ensuring interfaces in compile-time for AccountCancelPasswordEmailRequest.
var (
	_ bin.Encoder     = &AccountCancelPasswordEmailRequest{}
	_ bin.Decoder     = &AccountCancelPasswordEmailRequest{}
	_ bin.BareEncoder = &AccountCancelPasswordEmailRequest{}
	_ bin.BareDecoder = &AccountCancelPasswordEmailRequest{}
)

func (c *AccountCancelPasswordEmailRequest) Zero() bool {
	if c == nil {
		return true
	}

	return true
}

// String implements fmt.Stringer.
func (c *AccountCancelPasswordEmailRequest) String() string {
	if c == nil {
		return "AccountCancelPasswordEmailRequest(nil)"
	}
	type Alias AccountCancelPasswordEmailRequest
	return fmt.Sprintf("AccountCancelPasswordEmailRequest%+v", Alias(*c))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*AccountCancelPasswordEmailRequest) TypeID() uint32 {
	return AccountCancelPasswordEmailRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*AccountCancelPasswordEmailRequest) TypeName() string {
	return "account.cancelPasswordEmail"
}

// TypeInfo returns info about TL type.
func (c *AccountCancelPasswordEmailRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "account.cancelPasswordEmail",
		ID:   AccountCancelPasswordEmailRequestTypeID,
	}
	if c == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{}
	return typ
}

// Encode implements bin.Encoder.
func (c *AccountCancelPasswordEmailRequest) Encode(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't encode account.cancelPasswordEmail#c1cbd5b6 as nil")
	}
	b.PutID(AccountCancelPasswordEmailRequestTypeID)
	return c.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (c *AccountCancelPasswordEmailRequest) EncodeBare(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't encode account.cancelPasswordEmail#c1cbd5b6 as nil")
	}
	return nil
}

// Decode implements bin.Decoder.
func (c *AccountCancelPasswordEmailRequest) Decode(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't decode account.cancelPasswordEmail#c1cbd5b6 to nil")
	}
	if err := b.ConsumeID(AccountCancelPasswordEmailRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode account.cancelPasswordEmail#c1cbd5b6: %w", err)
	}
	return c.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (c *AccountCancelPasswordEmailRequest) DecodeBare(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't decode account.cancelPasswordEmail#c1cbd5b6 to nil")
	}
	return nil
}

// AccountCancelPasswordEmail invokes method account.cancelPasswordEmail#c1cbd5b6 returning error if any.
// Cancel the code that was sent to verify an email to use as 2FA recovery method¹.
//
// Links:
//  1) https://core.telegram.org/api/srp
//
// See https://core.telegram.org/method/account.cancelPasswordEmail for reference.
func (c *Client) AccountCancelPasswordEmail(ctx context.Context) (bool, error) {
	var result BoolBox

	request := &AccountCancelPasswordEmailRequest{}
	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return false, err
	}
	_, ok := result.Bool.(*BoolTrue)
	return ok, nil
}
