// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// AuthSignUpRequest represents TL type `auth.signUp#80eee427`.
// Registers a validated phone number in the system.
//
// See https://core.telegram.org/method/auth.signUp for reference.
type AuthSignUpRequest struct {
	// Phone number in the international format
	PhoneNumber string
	// SMS-message ID
	PhoneCodeHash string
	// New user first name
	FirstName string
	// New user last name
	LastName string
}

// AuthSignUpRequestTypeID is TL type id of AuthSignUpRequest.
const AuthSignUpRequestTypeID = 0x80eee427

// Ensuring interfaces in compile-time for AuthSignUpRequest.
var (
	_ bin.Encoder     = &AuthSignUpRequest{}
	_ bin.Decoder     = &AuthSignUpRequest{}
	_ bin.BareEncoder = &AuthSignUpRequest{}
	_ bin.BareDecoder = &AuthSignUpRequest{}
)

func (s *AuthSignUpRequest) Zero() bool {
	if s == nil {
		return true
	}
	if !(s.PhoneNumber == "") {
		return false
	}
	if !(s.PhoneCodeHash == "") {
		return false
	}
	if !(s.FirstName == "") {
		return false
	}
	if !(s.LastName == "") {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (s *AuthSignUpRequest) String() string {
	if s == nil {
		return "AuthSignUpRequest(nil)"
	}
	type Alias AuthSignUpRequest
	return fmt.Sprintf("AuthSignUpRequest%+v", Alias(*s))
}

// FillFrom fills AuthSignUpRequest from given interface.
func (s *AuthSignUpRequest) FillFrom(from interface {
	GetPhoneNumber() (value string)
	GetPhoneCodeHash() (value string)
	GetFirstName() (value string)
	GetLastName() (value string)
}) {
	s.PhoneNumber = from.GetPhoneNumber()
	s.PhoneCodeHash = from.GetPhoneCodeHash()
	s.FirstName = from.GetFirstName()
	s.LastName = from.GetLastName()
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*AuthSignUpRequest) TypeID() uint32 {
	return AuthSignUpRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*AuthSignUpRequest) TypeName() string {
	return "auth.signUp"
}

// TypeInfo returns info about TL type.
func (s *AuthSignUpRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "auth.signUp",
		ID:   AuthSignUpRequestTypeID,
	}
	if s == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "PhoneNumber",
			SchemaName: "phone_number",
		},
		{
			Name:       "PhoneCodeHash",
			SchemaName: "phone_code_hash",
		},
		{
			Name:       "FirstName",
			SchemaName: "first_name",
		},
		{
			Name:       "LastName",
			SchemaName: "last_name",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (s *AuthSignUpRequest) Encode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode auth.signUp#80eee427 as nil")
	}
	b.PutID(AuthSignUpRequestTypeID)
	return s.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (s *AuthSignUpRequest) EncodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode auth.signUp#80eee427 as nil")
	}
	b.PutString(s.PhoneNumber)
	b.PutString(s.PhoneCodeHash)
	b.PutString(s.FirstName)
	b.PutString(s.LastName)
	return nil
}

// Decode implements bin.Decoder.
func (s *AuthSignUpRequest) Decode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode auth.signUp#80eee427 to nil")
	}
	if err := b.ConsumeID(AuthSignUpRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode auth.signUp#80eee427: %w", err)
	}
	return s.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (s *AuthSignUpRequest) DecodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode auth.signUp#80eee427 to nil")
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode auth.signUp#80eee427: field phone_number: %w", err)
		}
		s.PhoneNumber = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode auth.signUp#80eee427: field phone_code_hash: %w", err)
		}
		s.PhoneCodeHash = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode auth.signUp#80eee427: field first_name: %w", err)
		}
		s.FirstName = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode auth.signUp#80eee427: field last_name: %w", err)
		}
		s.LastName = value
	}
	return nil
}

// GetPhoneNumber returns value of PhoneNumber field.
func (s *AuthSignUpRequest) GetPhoneNumber() (value string) {
	if s == nil {
		return
	}
	return s.PhoneNumber
}

// GetPhoneCodeHash returns value of PhoneCodeHash field.
func (s *AuthSignUpRequest) GetPhoneCodeHash() (value string) {
	if s == nil {
		return
	}
	return s.PhoneCodeHash
}

// GetFirstName returns value of FirstName field.
func (s *AuthSignUpRequest) GetFirstName() (value string) {
	if s == nil {
		return
	}
	return s.FirstName
}

// GetLastName returns value of LastName field.
func (s *AuthSignUpRequest) GetLastName() (value string) {
	if s == nil {
		return
	}
	return s.LastName
}

// AuthSignUp invokes method auth.signUp#80eee427 returning error if any.
// Registers a validated phone number in the system.
//
// Possible errors:
//  400 FIRSTNAME_INVALID: Invalid first name.
//  400 LASTNAME_INVALID: Invalid last name.
//  400 PHONE_CODE_EMPTY: phone_code from a SMS is empty.
//  400 PHONE_CODE_EXPIRED: SMS expired.
//  400 PHONE_CODE_INVALID: Invalid SMS code was sent.
//  400 PHONE_NUMBER_FLOOD: You asked for the code too many times.
//  400 PHONE_NUMBER_INVALID: Invalid phone number.
//  400 PHONE_NUMBER_OCCUPIED: The phone number is already in use.
//
// See https://core.telegram.org/method/auth.signUp for reference.
func (c *Client) AuthSignUp(ctx context.Context, request *AuthSignUpRequest) (AuthAuthorizationClass, error) {
	var result AuthAuthorizationBox

	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return result.Authorization, nil
}
