// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// ChannelsEditPhotoRequest represents TL type `channels.editPhoto#f12e57c9`.
// Change the photo of a channel/supergroup¹
//
// Links:
//  1) https://core.telegram.org/api/channel
//
// See https://core.telegram.org/method/channels.editPhoto for reference.
type ChannelsEditPhotoRequest struct {
	// Channel/supergroup whose photo should be edited
	Channel InputChannelClass
	// New photo
	Photo InputChatPhotoClass
}

// ChannelsEditPhotoRequestTypeID is TL type id of ChannelsEditPhotoRequest.
const ChannelsEditPhotoRequestTypeID = 0xf12e57c9

// Ensuring interfaces in compile-time for ChannelsEditPhotoRequest.
var (
	_ bin.Encoder     = &ChannelsEditPhotoRequest{}
	_ bin.Decoder     = &ChannelsEditPhotoRequest{}
	_ bin.BareEncoder = &ChannelsEditPhotoRequest{}
	_ bin.BareDecoder = &ChannelsEditPhotoRequest{}
)

func (e *ChannelsEditPhotoRequest) Zero() bool {
	if e == nil {
		return true
	}
	if !(e.Channel == nil) {
		return false
	}
	if !(e.Photo == nil) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (e *ChannelsEditPhotoRequest) String() string {
	if e == nil {
		return "ChannelsEditPhotoRequest(nil)"
	}
	type Alias ChannelsEditPhotoRequest
	return fmt.Sprintf("ChannelsEditPhotoRequest%+v", Alias(*e))
}

// FillFrom fills ChannelsEditPhotoRequest from given interface.
func (e *ChannelsEditPhotoRequest) FillFrom(from interface {
	GetChannel() (value InputChannelClass)
	GetPhoto() (value InputChatPhotoClass)
}) {
	e.Channel = from.GetChannel()
	e.Photo = from.GetPhoto()
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*ChannelsEditPhotoRequest) TypeID() uint32 {
	return ChannelsEditPhotoRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*ChannelsEditPhotoRequest) TypeName() string {
	return "channels.editPhoto"
}

// TypeInfo returns info about TL type.
func (e *ChannelsEditPhotoRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "channels.editPhoto",
		ID:   ChannelsEditPhotoRequestTypeID,
	}
	if e == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Channel",
			SchemaName: "channel",
		},
		{
			Name:       "Photo",
			SchemaName: "photo",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (e *ChannelsEditPhotoRequest) Encode(b *bin.Buffer) error {
	if e == nil {
		return fmt.Errorf("can't encode channels.editPhoto#f12e57c9 as nil")
	}
	b.PutID(ChannelsEditPhotoRequestTypeID)
	return e.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (e *ChannelsEditPhotoRequest) EncodeBare(b *bin.Buffer) error {
	if e == nil {
		return fmt.Errorf("can't encode channels.editPhoto#f12e57c9 as nil")
	}
	if e.Channel == nil {
		return fmt.Errorf("unable to encode channels.editPhoto#f12e57c9: field channel is nil")
	}
	if err := e.Channel.Encode(b); err != nil {
		return fmt.Errorf("unable to encode channels.editPhoto#f12e57c9: field channel: %w", err)
	}
	if e.Photo == nil {
		return fmt.Errorf("unable to encode channels.editPhoto#f12e57c9: field photo is nil")
	}
	if err := e.Photo.Encode(b); err != nil {
		return fmt.Errorf("unable to encode channels.editPhoto#f12e57c9: field photo: %w", err)
	}
	return nil
}

// Decode implements bin.Decoder.
func (e *ChannelsEditPhotoRequest) Decode(b *bin.Buffer) error {
	if e == nil {
		return fmt.Errorf("can't decode channels.editPhoto#f12e57c9 to nil")
	}
	if err := b.ConsumeID(ChannelsEditPhotoRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode channels.editPhoto#f12e57c9: %w", err)
	}
	return e.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (e *ChannelsEditPhotoRequest) DecodeBare(b *bin.Buffer) error {
	if e == nil {
		return fmt.Errorf("can't decode channels.editPhoto#f12e57c9 to nil")
	}
	{
		value, err := DecodeInputChannel(b)
		if err != nil {
			return fmt.Errorf("unable to decode channels.editPhoto#f12e57c9: field channel: %w", err)
		}
		e.Channel = value
	}
	{
		value, err := DecodeInputChatPhoto(b)
		if err != nil {
			return fmt.Errorf("unable to decode channels.editPhoto#f12e57c9: field photo: %w", err)
		}
		e.Photo = value
	}
	return nil
}

// GetChannel returns value of Channel field.
func (e *ChannelsEditPhotoRequest) GetChannel() (value InputChannelClass) {
	if e == nil {
		return
	}
	return e.Channel
}

// GetPhoto returns value of Photo field.
func (e *ChannelsEditPhotoRequest) GetPhoto() (value InputChatPhotoClass) {
	if e == nil {
		return
	}
	return e.Photo
}

// GetChannelAsNotEmpty returns mapped value of Channel field.
func (e *ChannelsEditPhotoRequest) GetChannelAsNotEmpty() (NotEmptyInputChannel, bool) {
	return e.Channel.AsNotEmpty()
}

// ChannelsEditPhoto invokes method channels.editPhoto#f12e57c9 returning error if any.
// Change the photo of a channel/supergroup¹
//
// Links:
//  1) https://core.telegram.org/api/channel
//
// Possible errors:
//  400 CHANNEL_INVALID: The provided channel is invalid.
//  400 CHANNEL_PRIVATE: You haven't joined this channel/supergroup.
//  400 CHAT_ADMIN_REQUIRED: You must be an admin in this chat to do this.
//  400 CHAT_NOT_MODIFIED: The pinned message wasn't modified.
//  403 CHAT_WRITE_FORBIDDEN: You can't write in this chat.
//  400 FILE_REFERENCE_INVALID: The specified file reference is invalid.
//  400 PHOTO_CROP_SIZE_SMALL: Photo is too small.
//  400 PHOTO_EXT_INVALID: The extension of the photo is invalid.
//  400 PHOTO_INVALID: Photo invalid.
//
// See https://core.telegram.org/method/channels.editPhoto for reference.
// Can be used by bots.
func (c *Client) ChannelsEditPhoto(ctx context.Context, request *ChannelsEditPhotoRequest) (UpdatesClass, error) {
	var result UpdatesBox

	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return result.Updates, nil
}
