// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// ChannelsSendAsPeers represents TL type `channels.sendAsPeers#8356cda9`.
//
// See https://core.telegram.org/constructor/channels.sendAsPeers for reference.
type ChannelsSendAsPeers struct {
	// Peers field of ChannelsSendAsPeers.
	Peers []PeerClass
	// Chats field of ChannelsSendAsPeers.
	Chats []ChatClass
	// Users field of ChannelsSendAsPeers.
	Users []UserClass
}

// ChannelsSendAsPeersTypeID is TL type id of ChannelsSendAsPeers.
const ChannelsSendAsPeersTypeID = 0x8356cda9

// Ensuring interfaces in compile-time for ChannelsSendAsPeers.
var (
	_ bin.Encoder     = &ChannelsSendAsPeers{}
	_ bin.Decoder     = &ChannelsSendAsPeers{}
	_ bin.BareEncoder = &ChannelsSendAsPeers{}
	_ bin.BareDecoder = &ChannelsSendAsPeers{}
)

func (s *ChannelsSendAsPeers) Zero() bool {
	if s == nil {
		return true
	}
	if !(s.Peers == nil) {
		return false
	}
	if !(s.Chats == nil) {
		return false
	}
	if !(s.Users == nil) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (s *ChannelsSendAsPeers) String() string {
	if s == nil {
		return "ChannelsSendAsPeers(nil)"
	}
	type Alias ChannelsSendAsPeers
	return fmt.Sprintf("ChannelsSendAsPeers%+v", Alias(*s))
}

// FillFrom fills ChannelsSendAsPeers from given interface.
func (s *ChannelsSendAsPeers) FillFrom(from interface {
	GetPeers() (value []PeerClass)
	GetChats() (value []ChatClass)
	GetUsers() (value []UserClass)
}) {
	s.Peers = from.GetPeers()
	s.Chats = from.GetChats()
	s.Users = from.GetUsers()
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*ChannelsSendAsPeers) TypeID() uint32 {
	return ChannelsSendAsPeersTypeID
}

// TypeName returns name of type in TL schema.
func (*ChannelsSendAsPeers) TypeName() string {
	return "channels.sendAsPeers"
}

// TypeInfo returns info about TL type.
func (s *ChannelsSendAsPeers) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "channels.sendAsPeers",
		ID:   ChannelsSendAsPeersTypeID,
	}
	if s == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Peers",
			SchemaName: "peers",
		},
		{
			Name:       "Chats",
			SchemaName: "chats",
		},
		{
			Name:       "Users",
			SchemaName: "users",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (s *ChannelsSendAsPeers) Encode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode channels.sendAsPeers#8356cda9 as nil")
	}
	b.PutID(ChannelsSendAsPeersTypeID)
	return s.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (s *ChannelsSendAsPeers) EncodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode channels.sendAsPeers#8356cda9 as nil")
	}
	b.PutVectorHeader(len(s.Peers))
	for idx, v := range s.Peers {
		if v == nil {
			return fmt.Errorf("unable to encode channels.sendAsPeers#8356cda9: field peers element with index %d is nil", idx)
		}
		if err := v.Encode(b); err != nil {
			return fmt.Errorf("unable to encode channels.sendAsPeers#8356cda9: field peers element with index %d: %w", idx, err)
		}
	}
	b.PutVectorHeader(len(s.Chats))
	for idx, v := range s.Chats {
		if v == nil {
			return fmt.Errorf("unable to encode channels.sendAsPeers#8356cda9: field chats element with index %d is nil", idx)
		}
		if err := v.Encode(b); err != nil {
			return fmt.Errorf("unable to encode channels.sendAsPeers#8356cda9: field chats element with index %d: %w", idx, err)
		}
	}
	b.PutVectorHeader(len(s.Users))
	for idx, v := range s.Users {
		if v == nil {
			return fmt.Errorf("unable to encode channels.sendAsPeers#8356cda9: field users element with index %d is nil", idx)
		}
		if err := v.Encode(b); err != nil {
			return fmt.Errorf("unable to encode channels.sendAsPeers#8356cda9: field users element with index %d: %w", idx, err)
		}
	}
	return nil
}

// Decode implements bin.Decoder.
func (s *ChannelsSendAsPeers) Decode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode channels.sendAsPeers#8356cda9 to nil")
	}
	if err := b.ConsumeID(ChannelsSendAsPeersTypeID); err != nil {
		return fmt.Errorf("unable to decode channels.sendAsPeers#8356cda9: %w", err)
	}
	return s.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (s *ChannelsSendAsPeers) DecodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode channels.sendAsPeers#8356cda9 to nil")
	}
	{
		headerLen, err := b.VectorHeader()
		if err != nil {
			return fmt.Errorf("unable to decode channels.sendAsPeers#8356cda9: field peers: %w", err)
		}

		if headerLen > 0 {
			s.Peers = make([]PeerClass, 0, headerLen%bin.PreallocateLimit)
		}
		for idx := 0; idx < headerLen; idx++ {
			value, err := DecodePeer(b)
			if err != nil {
				return fmt.Errorf("unable to decode channels.sendAsPeers#8356cda9: field peers: %w", err)
			}
			s.Peers = append(s.Peers, value)
		}
	}
	{
		headerLen, err := b.VectorHeader()
		if err != nil {
			return fmt.Errorf("unable to decode channels.sendAsPeers#8356cda9: field chats: %w", err)
		}

		if headerLen > 0 {
			s.Chats = make([]ChatClass, 0, headerLen%bin.PreallocateLimit)
		}
		for idx := 0; idx < headerLen; idx++ {
			value, err := DecodeChat(b)
			if err != nil {
				return fmt.Errorf("unable to decode channels.sendAsPeers#8356cda9: field chats: %w", err)
			}
			s.Chats = append(s.Chats, value)
		}
	}
	{
		headerLen, err := b.VectorHeader()
		if err != nil {
			return fmt.Errorf("unable to decode channels.sendAsPeers#8356cda9: field users: %w", err)
		}

		if headerLen > 0 {
			s.Users = make([]UserClass, 0, headerLen%bin.PreallocateLimit)
		}
		for idx := 0; idx < headerLen; idx++ {
			value, err := DecodeUser(b)
			if err != nil {
				return fmt.Errorf("unable to decode channels.sendAsPeers#8356cda9: field users: %w", err)
			}
			s.Users = append(s.Users, value)
		}
	}
	return nil
}

// GetPeers returns value of Peers field.
func (s *ChannelsSendAsPeers) GetPeers() (value []PeerClass) {
	if s == nil {
		return
	}
	return s.Peers
}

// GetChats returns value of Chats field.
func (s *ChannelsSendAsPeers) GetChats() (value []ChatClass) {
	if s == nil {
		return
	}
	return s.Chats
}

// GetUsers returns value of Users field.
func (s *ChannelsSendAsPeers) GetUsers() (value []UserClass) {
	if s == nil {
		return
	}
	return s.Users
}

// MapPeers returns field Peers wrapped in PeerClassArray helper.
func (s *ChannelsSendAsPeers) MapPeers() (value PeerClassArray) {
	return PeerClassArray(s.Peers)
}

// MapChats returns field Chats wrapped in ChatClassArray helper.
func (s *ChannelsSendAsPeers) MapChats() (value ChatClassArray) {
	return ChatClassArray(s.Chats)
}

// MapUsers returns field Users wrapped in UserClassArray helper.
func (s *ChannelsSendAsPeers) MapUsers() (value UserClassArray) {
	return UserClassArray(s.Users)
}
