// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// DialogFilterVector is a box for Vector<DialogFilter>
type DialogFilterVector struct {
	// Elements of Vector<DialogFilter>
	Elems []DialogFilter
}

// DialogFilterVectorTypeID is TL type id of DialogFilterVector.
const DialogFilterVectorTypeID = bin.TypeVector

// Ensuring interfaces in compile-time for DialogFilterVector.
var (
	_ bin.Encoder     = &DialogFilterVector{}
	_ bin.Decoder     = &DialogFilterVector{}
	_ bin.BareEncoder = &DialogFilterVector{}
	_ bin.BareDecoder = &DialogFilterVector{}
)

func (vec *DialogFilterVector) Zero() bool {
	if vec == nil {
		return true
	}
	if !(vec.Elems == nil) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (vec *DialogFilterVector) String() string {
	if vec == nil {
		return "DialogFilterVector(nil)"
	}
	type Alias DialogFilterVector
	return fmt.Sprintf("DialogFilterVector%+v", Alias(*vec))
}

// FillFrom fills DialogFilterVector from given interface.
func (vec *DialogFilterVector) FillFrom(from interface {
	GetElems() (value []DialogFilter)
}) {
	vec.Elems = from.GetElems()
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*DialogFilterVector) TypeID() uint32 {
	return DialogFilterVectorTypeID
}

// TypeName returns name of type in TL schema.
func (*DialogFilterVector) TypeName() string {
	return ""
}

// TypeInfo returns info about TL type.
func (vec *DialogFilterVector) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "",
		ID:   DialogFilterVectorTypeID,
	}
	if vec == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Elems",
			SchemaName: "Elems",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (vec *DialogFilterVector) Encode(b *bin.Buffer) error {
	if vec == nil {
		return fmt.Errorf("can't encode Vector<DialogFilter> as nil")
	}

	return vec.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (vec *DialogFilterVector) EncodeBare(b *bin.Buffer) error {
	if vec == nil {
		return fmt.Errorf("can't encode Vector<DialogFilter> as nil")
	}
	b.PutVectorHeader(len(vec.Elems))
	for idx, v := range vec.Elems {
		if err := v.Encode(b); err != nil {
			return fmt.Errorf("unable to encode Vector<DialogFilter>: field Elems element with index %d: %w", idx, err)
		}
	}
	return nil
}

// Decode implements bin.Decoder.
func (vec *DialogFilterVector) Decode(b *bin.Buffer) error {
	if vec == nil {
		return fmt.Errorf("can't decode Vector<DialogFilter> to nil")
	}

	return vec.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (vec *DialogFilterVector) DecodeBare(b *bin.Buffer) error {
	if vec == nil {
		return fmt.Errorf("can't decode Vector<DialogFilter> to nil")
	}
	{
		headerLen, err := b.VectorHeader()
		if err != nil {
			return fmt.Errorf("unable to decode Vector<DialogFilter>: field Elems: %w", err)
		}

		if headerLen > 0 {
			vec.Elems = make([]DialogFilter, 0, headerLen%bin.PreallocateLimit)
		}
		for idx := 0; idx < headerLen; idx++ {
			var value DialogFilter
			if err := value.Decode(b); err != nil {
				return fmt.Errorf("unable to decode Vector<DialogFilter>: field Elems: %w", err)
			}
			vec.Elems = append(vec.Elems, value)
		}
	}
	return nil
}

// GetElems returns value of Elems field.
func (vec *DialogFilterVector) GetElems() (value []DialogFilter) {
	if vec == nil {
		return
	}
	return vec.Elems
}
