//go:build !no_gotd_slices
// +build !no_gotd_slices

// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// DraftMessageClassArray is adapter for slice of DraftMessageClass.
type DraftMessageClassArray []DraftMessageClass

// Sort sorts slice of DraftMessageClass.
func (s DraftMessageClassArray) Sort(less func(a, b DraftMessageClass) bool) DraftMessageClassArray {
	sort.Slice(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// SortStable sorts slice of DraftMessageClass.
func (s DraftMessageClassArray) SortStable(less func(a, b DraftMessageClass) bool) DraftMessageClassArray {
	sort.SliceStable(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// Retain filters in-place slice of DraftMessageClass.
func (s DraftMessageClassArray) Retain(keep func(x DraftMessageClass) bool) DraftMessageClassArray {
	n := 0
	for _, x := range s {
		if keep(x) {
			s[n] = x
			n++
		}
	}
	s = s[:n]

	return s
}

// First returns first element of slice (if exists).
func (s DraftMessageClassArray) First() (v DraftMessageClass, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[0], true
}

// Last returns last element of slice (if exists).
func (s DraftMessageClassArray) Last() (v DraftMessageClass, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[len(s)-1], true
}

// PopFirst returns first element of slice (if exists) and deletes it.
func (s *DraftMessageClassArray) PopFirst() (v DraftMessageClass, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[0]

	// Delete by index from SliceTricks.
	copy(a[0:], a[1:])
	var zero DraftMessageClass
	a[len(a)-1] = zero
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// Pop returns last element of slice (if exists) and deletes it.
func (s *DraftMessageClassArray) Pop() (v DraftMessageClass, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[len(a)-1]
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// AsDraftMessageEmpty returns copy with only DraftMessageEmpty constructors.
func (s DraftMessageClassArray) AsDraftMessageEmpty() (to DraftMessageEmptyArray) {
	for _, elem := range s {
		value, ok := elem.(*DraftMessageEmpty)
		if !ok {
			continue
		}
		to = append(to, *value)
	}

	return to
}

// AsDraftMessage returns copy with only DraftMessage constructors.
func (s DraftMessageClassArray) AsDraftMessage() (to DraftMessageArray) {
	for _, elem := range s {
		value, ok := elem.(*DraftMessage)
		if !ok {
			continue
		}
		to = append(to, *value)
	}

	return to
}

// AppendOnlyNotEmpty appends only NotEmpty constructors to
// given slice.
func (s DraftMessageClassArray) AppendOnlyNotEmpty(to []*DraftMessage) []*DraftMessage {
	for _, elem := range s {
		value, ok := elem.AsNotEmpty()
		if !ok {
			continue
		}
		to = append(to, value)
	}

	return to
}

// AsNotEmpty returns copy with only NotEmpty constructors.
func (s DraftMessageClassArray) AsNotEmpty() (to []*DraftMessage) {
	return s.AppendOnlyNotEmpty(to)
}

// FirstAsNotEmpty returns first element of slice (if exists).
func (s DraftMessageClassArray) FirstAsNotEmpty() (v *DraftMessage, ok bool) {
	value, ok := s.First()
	if !ok {
		return
	}
	return value.AsNotEmpty()
}

// LastAsNotEmpty returns last element of slice (if exists).
func (s DraftMessageClassArray) LastAsNotEmpty() (v *DraftMessage, ok bool) {
	value, ok := s.Last()
	if !ok {
		return
	}
	return value.AsNotEmpty()
}

// PopFirstAsNotEmpty returns element of slice (if exists).
func (s *DraftMessageClassArray) PopFirstAsNotEmpty() (v *DraftMessage, ok bool) {
	value, ok := s.PopFirst()
	if !ok {
		return
	}
	return value.AsNotEmpty()
}

// PopAsNotEmpty returns element of slice (if exists).
func (s *DraftMessageClassArray) PopAsNotEmpty() (v *DraftMessage, ok bool) {
	value, ok := s.Pop()
	if !ok {
		return
	}
	return value.AsNotEmpty()
}

// DraftMessageEmptyArray is adapter for slice of DraftMessageEmpty.
type DraftMessageEmptyArray []DraftMessageEmpty

// Sort sorts slice of DraftMessageEmpty.
func (s DraftMessageEmptyArray) Sort(less func(a, b DraftMessageEmpty) bool) DraftMessageEmptyArray {
	sort.Slice(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// SortStable sorts slice of DraftMessageEmpty.
func (s DraftMessageEmptyArray) SortStable(less func(a, b DraftMessageEmpty) bool) DraftMessageEmptyArray {
	sort.SliceStable(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// Retain filters in-place slice of DraftMessageEmpty.
func (s DraftMessageEmptyArray) Retain(keep func(x DraftMessageEmpty) bool) DraftMessageEmptyArray {
	n := 0
	for _, x := range s {
		if keep(x) {
			s[n] = x
			n++
		}
	}
	s = s[:n]

	return s
}

// First returns first element of slice (if exists).
func (s DraftMessageEmptyArray) First() (v DraftMessageEmpty, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[0], true
}

// Last returns last element of slice (if exists).
func (s DraftMessageEmptyArray) Last() (v DraftMessageEmpty, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[len(s)-1], true
}

// PopFirst returns first element of slice (if exists) and deletes it.
func (s *DraftMessageEmptyArray) PopFirst() (v DraftMessageEmpty, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[0]

	// Delete by index from SliceTricks.
	copy(a[0:], a[1:])
	var zero DraftMessageEmpty
	a[len(a)-1] = zero
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// Pop returns last element of slice (if exists) and deletes it.
func (s *DraftMessageEmptyArray) Pop() (v DraftMessageEmpty, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[len(a)-1]
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// DraftMessageArray is adapter for slice of DraftMessage.
type DraftMessageArray []DraftMessage

// Sort sorts slice of DraftMessage.
func (s DraftMessageArray) Sort(less func(a, b DraftMessage) bool) DraftMessageArray {
	sort.Slice(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// SortStable sorts slice of DraftMessage.
func (s DraftMessageArray) SortStable(less func(a, b DraftMessage) bool) DraftMessageArray {
	sort.SliceStable(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// Retain filters in-place slice of DraftMessage.
func (s DraftMessageArray) Retain(keep func(x DraftMessage) bool) DraftMessageArray {
	n := 0
	for _, x := range s {
		if keep(x) {
			s[n] = x
			n++
		}
	}
	s = s[:n]

	return s
}

// First returns first element of slice (if exists).
func (s DraftMessageArray) First() (v DraftMessage, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[0], true
}

// Last returns last element of slice (if exists).
func (s DraftMessageArray) Last() (v DraftMessage, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[len(s)-1], true
}

// PopFirst returns first element of slice (if exists) and deletes it.
func (s *DraftMessageArray) PopFirst() (v DraftMessage, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[0]

	// Delete by index from SliceTricks.
	copy(a[0:], a[1:])
	var zero DraftMessage
	a[len(a)-1] = zero
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// Pop returns last element of slice (if exists) and deletes it.
func (s *DraftMessageArray) Pop() (v DraftMessage, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[len(a)-1]
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// SortByDate sorts slice of DraftMessage by Date.
func (s DraftMessageArray) SortByDate() DraftMessageArray {
	return s.Sort(func(a, b DraftMessage) bool {
		return a.GetDate() < b.GetDate()
	})
}

// SortStableByDate sorts slice of DraftMessage by Date.
func (s DraftMessageArray) SortStableByDate() DraftMessageArray {
	return s.SortStable(func(a, b DraftMessage) bool {
		return a.GetDate() < b.GetDate()
	})
}
