// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// FoldersDeleteFolderRequest represents TL type `folders.deleteFolder#1c295881`.
// Delete a peer folder¹
//
// Links:
//  1) https://core.telegram.org/api/folders#peer-folders
//
// See https://core.telegram.org/method/folders.deleteFolder for reference.
type FoldersDeleteFolderRequest struct {
	// Peer folder ID, for more info click here¹
	//
	// Links:
	//  1) https://core.telegram.org/api/folders#peer-folders
	FolderID int
}

// FoldersDeleteFolderRequestTypeID is TL type id of FoldersDeleteFolderRequest.
const FoldersDeleteFolderRequestTypeID = 0x1c295881

// Ensuring interfaces in compile-time for FoldersDeleteFolderRequest.
var (
	_ bin.Encoder     = &FoldersDeleteFolderRequest{}
	_ bin.Decoder     = &FoldersDeleteFolderRequest{}
	_ bin.BareEncoder = &FoldersDeleteFolderRequest{}
	_ bin.BareDecoder = &FoldersDeleteFolderRequest{}
)

func (d *FoldersDeleteFolderRequest) Zero() bool {
	if d == nil {
		return true
	}
	if !(d.FolderID == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (d *FoldersDeleteFolderRequest) String() string {
	if d == nil {
		return "FoldersDeleteFolderRequest(nil)"
	}
	type Alias FoldersDeleteFolderRequest
	return fmt.Sprintf("FoldersDeleteFolderRequest%+v", Alias(*d))
}

// FillFrom fills FoldersDeleteFolderRequest from given interface.
func (d *FoldersDeleteFolderRequest) FillFrom(from interface {
	GetFolderID() (value int)
}) {
	d.FolderID = from.GetFolderID()
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*FoldersDeleteFolderRequest) TypeID() uint32 {
	return FoldersDeleteFolderRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*FoldersDeleteFolderRequest) TypeName() string {
	return "folders.deleteFolder"
}

// TypeInfo returns info about TL type.
func (d *FoldersDeleteFolderRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "folders.deleteFolder",
		ID:   FoldersDeleteFolderRequestTypeID,
	}
	if d == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "FolderID",
			SchemaName: "folder_id",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (d *FoldersDeleteFolderRequest) Encode(b *bin.Buffer) error {
	if d == nil {
		return fmt.Errorf("can't encode folders.deleteFolder#1c295881 as nil")
	}
	b.PutID(FoldersDeleteFolderRequestTypeID)
	return d.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (d *FoldersDeleteFolderRequest) EncodeBare(b *bin.Buffer) error {
	if d == nil {
		return fmt.Errorf("can't encode folders.deleteFolder#1c295881 as nil")
	}
	b.PutInt(d.FolderID)
	return nil
}

// Decode implements bin.Decoder.
func (d *FoldersDeleteFolderRequest) Decode(b *bin.Buffer) error {
	if d == nil {
		return fmt.Errorf("can't decode folders.deleteFolder#1c295881 to nil")
	}
	if err := b.ConsumeID(FoldersDeleteFolderRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode folders.deleteFolder#1c295881: %w", err)
	}
	return d.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (d *FoldersDeleteFolderRequest) DecodeBare(b *bin.Buffer) error {
	if d == nil {
		return fmt.Errorf("can't decode folders.deleteFolder#1c295881 to nil")
	}
	{
		value, err := b.Int()
		if err != nil {
			return fmt.Errorf("unable to decode folders.deleteFolder#1c295881: field folder_id: %w", err)
		}
		d.FolderID = value
	}
	return nil
}

// GetFolderID returns value of FolderID field.
func (d *FoldersDeleteFolderRequest) GetFolderID() (value int) {
	if d == nil {
		return
	}
	return d.FolderID
}

// FoldersDeleteFolder invokes method folders.deleteFolder#1c295881 returning error if any.
// Delete a peer folder¹
//
// Links:
//  1) https://core.telegram.org/api/folders#peer-folders
//
// Possible errors:
//  400 FOLDER_ID_EMPTY: An empty folder ID was specified.
//
// See https://core.telegram.org/method/folders.deleteFolder for reference.
func (c *Client) FoldersDeleteFolder(ctx context.Context, folderid int) (UpdatesClass, error) {
	var result UpdatesBox

	request := &FoldersDeleteFolderRequest{
		FolderID: folderid,
	}
	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return result.Updates, nil
}
