// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// HelpGetAppConfigRequest represents TL type `help.getAppConfig#98914110`.
// Get app-specific configuration, see client configuration¹ for more info on the result.
//
// Links:
//  1) https://core.telegram.org/api/config#client-configuration
//
// See https://core.telegram.org/method/help.getAppConfig for reference.
type HelpGetAppConfigRequest struct {
}

// HelpGetAppConfigRequestTypeID is TL type id of HelpGetAppConfigRequest.
const HelpGetAppConfigRequestTypeID = 0x98914110

// Ensuring interfaces in compile-time for HelpGetAppConfigRequest.
var (
	_ bin.Encoder     = &HelpGetAppConfigRequest{}
	_ bin.Decoder     = &HelpGetAppConfigRequest{}
	_ bin.BareEncoder = &HelpGetAppConfigRequest{}
	_ bin.BareDecoder = &HelpGetAppConfigRequest{}
)

func (g *HelpGetAppConfigRequest) Zero() bool {
	if g == nil {
		return true
	}

	return true
}

// String implements fmt.Stringer.
func (g *HelpGetAppConfigRequest) String() string {
	if g == nil {
		return "HelpGetAppConfigRequest(nil)"
	}
	type Alias HelpGetAppConfigRequest
	return fmt.Sprintf("HelpGetAppConfigRequest%+v", Alias(*g))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*HelpGetAppConfigRequest) TypeID() uint32 {
	return HelpGetAppConfigRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*HelpGetAppConfigRequest) TypeName() string {
	return "help.getAppConfig"
}

// TypeInfo returns info about TL type.
func (g *HelpGetAppConfigRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "help.getAppConfig",
		ID:   HelpGetAppConfigRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{}
	return typ
}

// Encode implements bin.Encoder.
func (g *HelpGetAppConfigRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode help.getAppConfig#98914110 as nil")
	}
	b.PutID(HelpGetAppConfigRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *HelpGetAppConfigRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode help.getAppConfig#98914110 as nil")
	}
	return nil
}

// Decode implements bin.Decoder.
func (g *HelpGetAppConfigRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode help.getAppConfig#98914110 to nil")
	}
	if err := b.ConsumeID(HelpGetAppConfigRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode help.getAppConfig#98914110: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *HelpGetAppConfigRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode help.getAppConfig#98914110 to nil")
	}
	return nil
}

// HelpGetAppConfig invokes method help.getAppConfig#98914110 returning error if any.
// Get app-specific configuration, see client configuration¹ for more info on the result.
//
// Links:
//  1) https://core.telegram.org/api/config#client-configuration
//
// See https://core.telegram.org/method/help.getAppConfig for reference.
func (c *Client) HelpGetAppConfig(ctx context.Context) (JSONValueClass, error) {
	var result JSONValueBox

	request := &HelpGetAppConfigRequest{}
	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return result.JSONValue, nil
}
