// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// HelpGetCDNConfigRequest represents TL type `help.getCdnConfig#52029342`.
// Get configuration for CDN¹ file downloads.
//
// Links:
//  1) https://core.telegram.org/cdn
//
// See https://core.telegram.org/method/help.getCdnConfig for reference.
type HelpGetCDNConfigRequest struct {
}

// HelpGetCDNConfigRequestTypeID is TL type id of HelpGetCDNConfigRequest.
const HelpGetCDNConfigRequestTypeID = 0x52029342

// Ensuring interfaces in compile-time for HelpGetCDNConfigRequest.
var (
	_ bin.Encoder     = &HelpGetCDNConfigRequest{}
	_ bin.Decoder     = &HelpGetCDNConfigRequest{}
	_ bin.BareEncoder = &HelpGetCDNConfigRequest{}
	_ bin.BareDecoder = &HelpGetCDNConfigRequest{}
)

func (g *HelpGetCDNConfigRequest) Zero() bool {
	if g == nil {
		return true
	}

	return true
}

// String implements fmt.Stringer.
func (g *HelpGetCDNConfigRequest) String() string {
	if g == nil {
		return "HelpGetCDNConfigRequest(nil)"
	}
	type Alias HelpGetCDNConfigRequest
	return fmt.Sprintf("HelpGetCDNConfigRequest%+v", Alias(*g))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*HelpGetCDNConfigRequest) TypeID() uint32 {
	return HelpGetCDNConfigRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*HelpGetCDNConfigRequest) TypeName() string {
	return "help.getCdnConfig"
}

// TypeInfo returns info about TL type.
func (g *HelpGetCDNConfigRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "help.getCdnConfig",
		ID:   HelpGetCDNConfigRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{}
	return typ
}

// Encode implements bin.Encoder.
func (g *HelpGetCDNConfigRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode help.getCdnConfig#52029342 as nil")
	}
	b.PutID(HelpGetCDNConfigRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *HelpGetCDNConfigRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode help.getCdnConfig#52029342 as nil")
	}
	return nil
}

// Decode implements bin.Decoder.
func (g *HelpGetCDNConfigRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode help.getCdnConfig#52029342 to nil")
	}
	if err := b.ConsumeID(HelpGetCDNConfigRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode help.getCdnConfig#52029342: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *HelpGetCDNConfigRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode help.getCdnConfig#52029342 to nil")
	}
	return nil
}

// HelpGetCDNConfig invokes method help.getCdnConfig#52029342 returning error if any.
// Get configuration for CDN¹ file downloads.
//
// Links:
//  1) https://core.telegram.org/cdn
//
// Possible errors:
//  401 AUTH_KEY_PERM_EMPTY: The temporary auth key must be binded to the permanent auth key to use these methods.
//
// See https://core.telegram.org/method/help.getCdnConfig for reference.
// Can be used by bots.
func (c *Client) HelpGetCDNConfig(ctx context.Context) (*CDNConfig, error) {
	var result CDNConfig

	request := &HelpGetCDNConfigRequest{}
	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
