//go:build !no_gotd_slices
// +build !no_gotd_slices

// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// InputChannelClassArray is adapter for slice of InputChannelClass.
type InputChannelClassArray []InputChannelClass

// Sort sorts slice of InputChannelClass.
func (s InputChannelClassArray) Sort(less func(a, b InputChannelClass) bool) InputChannelClassArray {
	sort.Slice(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// SortStable sorts slice of InputChannelClass.
func (s InputChannelClassArray) SortStable(less func(a, b InputChannelClass) bool) InputChannelClassArray {
	sort.SliceStable(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// Retain filters in-place slice of InputChannelClass.
func (s InputChannelClassArray) Retain(keep func(x InputChannelClass) bool) InputChannelClassArray {
	n := 0
	for _, x := range s {
		if keep(x) {
			s[n] = x
			n++
		}
	}
	s = s[:n]

	return s
}

// First returns first element of slice (if exists).
func (s InputChannelClassArray) First() (v InputChannelClass, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[0], true
}

// Last returns last element of slice (if exists).
func (s InputChannelClassArray) Last() (v InputChannelClass, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[len(s)-1], true
}

// PopFirst returns first element of slice (if exists) and deletes it.
func (s *InputChannelClassArray) PopFirst() (v InputChannelClass, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[0]

	// Delete by index from SliceTricks.
	copy(a[0:], a[1:])
	var zero InputChannelClass
	a[len(a)-1] = zero
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// Pop returns last element of slice (if exists) and deletes it.
func (s *InputChannelClassArray) Pop() (v InputChannelClass, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[len(a)-1]
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// AsInputChannel returns copy with only InputChannel constructors.
func (s InputChannelClassArray) AsInputChannel() (to InputChannelArray) {
	for _, elem := range s {
		value, ok := elem.(*InputChannel)
		if !ok {
			continue
		}
		to = append(to, *value)
	}

	return to
}

// AsInputChannelFromMessage returns copy with only InputChannelFromMessage constructors.
func (s InputChannelClassArray) AsInputChannelFromMessage() (to InputChannelFromMessageArray) {
	for _, elem := range s {
		value, ok := elem.(*InputChannelFromMessage)
		if !ok {
			continue
		}
		to = append(to, *value)
	}

	return to
}

// AppendOnlyNotEmpty appends only NotEmpty constructors to
// given slice.
func (s InputChannelClassArray) AppendOnlyNotEmpty(to []NotEmptyInputChannel) []NotEmptyInputChannel {
	for _, elem := range s {
		value, ok := elem.AsNotEmpty()
		if !ok {
			continue
		}
		to = append(to, value)
	}

	return to
}

// AsNotEmpty returns copy with only NotEmpty constructors.
func (s InputChannelClassArray) AsNotEmpty() (to []NotEmptyInputChannel) {
	return s.AppendOnlyNotEmpty(to)
}

// FirstAsNotEmpty returns first element of slice (if exists).
func (s InputChannelClassArray) FirstAsNotEmpty() (v NotEmptyInputChannel, ok bool) {
	value, ok := s.First()
	if !ok {
		return
	}
	return value.AsNotEmpty()
}

// LastAsNotEmpty returns last element of slice (if exists).
func (s InputChannelClassArray) LastAsNotEmpty() (v NotEmptyInputChannel, ok bool) {
	value, ok := s.Last()
	if !ok {
		return
	}
	return value.AsNotEmpty()
}

// PopFirstAsNotEmpty returns element of slice (if exists).
func (s *InputChannelClassArray) PopFirstAsNotEmpty() (v NotEmptyInputChannel, ok bool) {
	value, ok := s.PopFirst()
	if !ok {
		return
	}
	return value.AsNotEmpty()
}

// PopAsNotEmpty returns element of slice (if exists).
func (s *InputChannelClassArray) PopAsNotEmpty() (v NotEmptyInputChannel, ok bool) {
	value, ok := s.Pop()
	if !ok {
		return
	}
	return value.AsNotEmpty()
}

// InputChannelArray is adapter for slice of InputChannel.
type InputChannelArray []InputChannel

// Sort sorts slice of InputChannel.
func (s InputChannelArray) Sort(less func(a, b InputChannel) bool) InputChannelArray {
	sort.Slice(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// SortStable sorts slice of InputChannel.
func (s InputChannelArray) SortStable(less func(a, b InputChannel) bool) InputChannelArray {
	sort.SliceStable(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// Retain filters in-place slice of InputChannel.
func (s InputChannelArray) Retain(keep func(x InputChannel) bool) InputChannelArray {
	n := 0
	for _, x := range s {
		if keep(x) {
			s[n] = x
			n++
		}
	}
	s = s[:n]

	return s
}

// First returns first element of slice (if exists).
func (s InputChannelArray) First() (v InputChannel, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[0], true
}

// Last returns last element of slice (if exists).
func (s InputChannelArray) Last() (v InputChannel, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[len(s)-1], true
}

// PopFirst returns first element of slice (if exists) and deletes it.
func (s *InputChannelArray) PopFirst() (v InputChannel, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[0]

	// Delete by index from SliceTricks.
	copy(a[0:], a[1:])
	var zero InputChannel
	a[len(a)-1] = zero
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// Pop returns last element of slice (if exists) and deletes it.
func (s *InputChannelArray) Pop() (v InputChannel, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[len(a)-1]
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// InputChannelFromMessageArray is adapter for slice of InputChannelFromMessage.
type InputChannelFromMessageArray []InputChannelFromMessage

// Sort sorts slice of InputChannelFromMessage.
func (s InputChannelFromMessageArray) Sort(less func(a, b InputChannelFromMessage) bool) InputChannelFromMessageArray {
	sort.Slice(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// SortStable sorts slice of InputChannelFromMessage.
func (s InputChannelFromMessageArray) SortStable(less func(a, b InputChannelFromMessage) bool) InputChannelFromMessageArray {
	sort.SliceStable(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// Retain filters in-place slice of InputChannelFromMessage.
func (s InputChannelFromMessageArray) Retain(keep func(x InputChannelFromMessage) bool) InputChannelFromMessageArray {
	n := 0
	for _, x := range s {
		if keep(x) {
			s[n] = x
			n++
		}
	}
	s = s[:n]

	return s
}

// First returns first element of slice (if exists).
func (s InputChannelFromMessageArray) First() (v InputChannelFromMessage, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[0], true
}

// Last returns last element of slice (if exists).
func (s InputChannelFromMessageArray) Last() (v InputChannelFromMessage, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[len(s)-1], true
}

// PopFirst returns first element of slice (if exists) and deletes it.
func (s *InputChannelFromMessageArray) PopFirst() (v InputChannelFromMessage, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[0]

	// Delete by index from SliceTricks.
	copy(a[0:], a[1:])
	var zero InputChannelFromMessage
	a[len(a)-1] = zero
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// Pop returns last element of slice (if exists) and deletes it.
func (s *InputChannelFromMessageArray) Pop() (v InputChannelFromMessage, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[len(a)-1]
	a = a[:len(a)-1]
	*s = a

	return v, true
}
