//go:build !no_gotd_slices
// +build !no_gotd_slices

// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// InputUserClassArray is adapter for slice of InputUserClass.
type InputUserClassArray []InputUserClass

// Sort sorts slice of InputUserClass.
func (s InputUserClassArray) Sort(less func(a, b InputUserClass) bool) InputUserClassArray {
	sort.Slice(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// SortStable sorts slice of InputUserClass.
func (s InputUserClassArray) SortStable(less func(a, b InputUserClass) bool) InputUserClassArray {
	sort.SliceStable(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// Retain filters in-place slice of InputUserClass.
func (s InputUserClassArray) Retain(keep func(x InputUserClass) bool) InputUserClassArray {
	n := 0
	for _, x := range s {
		if keep(x) {
			s[n] = x
			n++
		}
	}
	s = s[:n]

	return s
}

// First returns first element of slice (if exists).
func (s InputUserClassArray) First() (v InputUserClass, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[0], true
}

// Last returns last element of slice (if exists).
func (s InputUserClassArray) Last() (v InputUserClass, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[len(s)-1], true
}

// PopFirst returns first element of slice (if exists) and deletes it.
func (s *InputUserClassArray) PopFirst() (v InputUserClass, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[0]

	// Delete by index from SliceTricks.
	copy(a[0:], a[1:])
	var zero InputUserClass
	a[len(a)-1] = zero
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// Pop returns last element of slice (if exists) and deletes it.
func (s *InputUserClassArray) Pop() (v InputUserClass, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[len(a)-1]
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// AsInputUser returns copy with only InputUser constructors.
func (s InputUserClassArray) AsInputUser() (to InputUserArray) {
	for _, elem := range s {
		value, ok := elem.(*InputUser)
		if !ok {
			continue
		}
		to = append(to, *value)
	}

	return to
}

// AsInputUserFromMessage returns copy with only InputUserFromMessage constructors.
func (s InputUserClassArray) AsInputUserFromMessage() (to InputUserFromMessageArray) {
	for _, elem := range s {
		value, ok := elem.(*InputUserFromMessage)
		if !ok {
			continue
		}
		to = append(to, *value)
	}

	return to
}

// InputUserArray is adapter for slice of InputUser.
type InputUserArray []InputUser

// Sort sorts slice of InputUser.
func (s InputUserArray) Sort(less func(a, b InputUser) bool) InputUserArray {
	sort.Slice(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// SortStable sorts slice of InputUser.
func (s InputUserArray) SortStable(less func(a, b InputUser) bool) InputUserArray {
	sort.SliceStable(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// Retain filters in-place slice of InputUser.
func (s InputUserArray) Retain(keep func(x InputUser) bool) InputUserArray {
	n := 0
	for _, x := range s {
		if keep(x) {
			s[n] = x
			n++
		}
	}
	s = s[:n]

	return s
}

// First returns first element of slice (if exists).
func (s InputUserArray) First() (v InputUser, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[0], true
}

// Last returns last element of slice (if exists).
func (s InputUserArray) Last() (v InputUser, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[len(s)-1], true
}

// PopFirst returns first element of slice (if exists) and deletes it.
func (s *InputUserArray) PopFirst() (v InputUser, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[0]

	// Delete by index from SliceTricks.
	copy(a[0:], a[1:])
	var zero InputUser
	a[len(a)-1] = zero
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// Pop returns last element of slice (if exists) and deletes it.
func (s *InputUserArray) Pop() (v InputUser, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[len(a)-1]
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// InputUserFromMessageArray is adapter for slice of InputUserFromMessage.
type InputUserFromMessageArray []InputUserFromMessage

// Sort sorts slice of InputUserFromMessage.
func (s InputUserFromMessageArray) Sort(less func(a, b InputUserFromMessage) bool) InputUserFromMessageArray {
	sort.Slice(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// SortStable sorts slice of InputUserFromMessage.
func (s InputUserFromMessageArray) SortStable(less func(a, b InputUserFromMessage) bool) InputUserFromMessageArray {
	sort.SliceStable(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// Retain filters in-place slice of InputUserFromMessage.
func (s InputUserFromMessageArray) Retain(keep func(x InputUserFromMessage) bool) InputUserFromMessageArray {
	n := 0
	for _, x := range s {
		if keep(x) {
			s[n] = x
			n++
		}
	}
	s = s[:n]

	return s
}

// First returns first element of slice (if exists).
func (s InputUserFromMessageArray) First() (v InputUserFromMessage, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[0], true
}

// Last returns last element of slice (if exists).
func (s InputUserFromMessageArray) Last() (v InputUserFromMessage, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[len(s)-1], true
}

// PopFirst returns first element of slice (if exists) and deletes it.
func (s *InputUserFromMessageArray) PopFirst() (v InputUserFromMessage, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[0]

	// Delete by index from SliceTricks.
	copy(a[0:], a[1:])
	var zero InputUserFromMessage
	a[len(a)-1] = zero
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// Pop returns last element of slice (if exists) and deletes it.
func (s *InputUserFromMessageArray) Pop() (v InputUserFromMessage, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[len(a)-1]
	a = a[:len(a)-1]
	*s = a

	return v, true
}
