// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// LangpackGetLanguagesRequest represents TL type `langpack.getLanguages#42c6978f`.
// Get information about all languages in a localization pack
//
// See https://core.telegram.org/method/langpack.getLanguages for reference.
type LangpackGetLanguagesRequest struct {
	// Language pack
	LangPack string
}

// LangpackGetLanguagesRequestTypeID is TL type id of LangpackGetLanguagesRequest.
const LangpackGetLanguagesRequestTypeID = 0x42c6978f

// Ensuring interfaces in compile-time for LangpackGetLanguagesRequest.
var (
	_ bin.Encoder     = &LangpackGetLanguagesRequest{}
	_ bin.Decoder     = &LangpackGetLanguagesRequest{}
	_ bin.BareEncoder = &LangpackGetLanguagesRequest{}
	_ bin.BareDecoder = &LangpackGetLanguagesRequest{}
)

func (g *LangpackGetLanguagesRequest) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.LangPack == "") {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *LangpackGetLanguagesRequest) String() string {
	if g == nil {
		return "LangpackGetLanguagesRequest(nil)"
	}
	type Alias LangpackGetLanguagesRequest
	return fmt.Sprintf("LangpackGetLanguagesRequest%+v", Alias(*g))
}

// FillFrom fills LangpackGetLanguagesRequest from given interface.
func (g *LangpackGetLanguagesRequest) FillFrom(from interface {
	GetLangPack() (value string)
}) {
	g.LangPack = from.GetLangPack()
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*LangpackGetLanguagesRequest) TypeID() uint32 {
	return LangpackGetLanguagesRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*LangpackGetLanguagesRequest) TypeName() string {
	return "langpack.getLanguages"
}

// TypeInfo returns info about TL type.
func (g *LangpackGetLanguagesRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "langpack.getLanguages",
		ID:   LangpackGetLanguagesRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "LangPack",
			SchemaName: "lang_pack",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *LangpackGetLanguagesRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode langpack.getLanguages#42c6978f as nil")
	}
	b.PutID(LangpackGetLanguagesRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *LangpackGetLanguagesRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode langpack.getLanguages#42c6978f as nil")
	}
	b.PutString(g.LangPack)
	return nil
}

// Decode implements bin.Decoder.
func (g *LangpackGetLanguagesRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode langpack.getLanguages#42c6978f to nil")
	}
	if err := b.ConsumeID(LangpackGetLanguagesRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode langpack.getLanguages#42c6978f: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *LangpackGetLanguagesRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode langpack.getLanguages#42c6978f to nil")
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode langpack.getLanguages#42c6978f: field lang_pack: %w", err)
		}
		g.LangPack = value
	}
	return nil
}

// GetLangPack returns value of LangPack field.
func (g *LangpackGetLanguagesRequest) GetLangPack() (value string) {
	if g == nil {
		return
	}
	return g.LangPack
}

// LangpackGetLanguages invokes method langpack.getLanguages#42c6978f returning error if any.
// Get information about all languages in a localization pack
//
// Possible errors:
//  400 LANG_PACK_INVALID: The provided language pack is invalid.
//
// See https://core.telegram.org/method/langpack.getLanguages for reference.
func (c *Client) LangpackGetLanguages(ctx context.Context, langpack string) ([]LangPackLanguage, error) {
	var result LangPackLanguageVector

	request := &LangpackGetLanguagesRequest{
		LangPack: langpack,
	}
	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return []LangPackLanguage(result.Elems), nil
}
