// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// MessagesChatAdminsWithInvites represents TL type `messages.chatAdminsWithInvites#b69b72d7`.
// Info about chat invites generated by admins.
//
// See https://core.telegram.org/constructor/messages.chatAdminsWithInvites for reference.
type MessagesChatAdminsWithInvites struct {
	// Info about chat invites generated by admins.
	Admins []ChatAdminWithInvites
	// Mentioned users
	Users []UserClass
}

// MessagesChatAdminsWithInvitesTypeID is TL type id of MessagesChatAdminsWithInvites.
const MessagesChatAdminsWithInvitesTypeID = 0xb69b72d7

// Ensuring interfaces in compile-time for MessagesChatAdminsWithInvites.
var (
	_ bin.Encoder     = &MessagesChatAdminsWithInvites{}
	_ bin.Decoder     = &MessagesChatAdminsWithInvites{}
	_ bin.BareEncoder = &MessagesChatAdminsWithInvites{}
	_ bin.BareDecoder = &MessagesChatAdminsWithInvites{}
)

func (c *MessagesChatAdminsWithInvites) Zero() bool {
	if c == nil {
		return true
	}
	if !(c.Admins == nil) {
		return false
	}
	if !(c.Users == nil) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (c *MessagesChatAdminsWithInvites) String() string {
	if c == nil {
		return "MessagesChatAdminsWithInvites(nil)"
	}
	type Alias MessagesChatAdminsWithInvites
	return fmt.Sprintf("MessagesChatAdminsWithInvites%+v", Alias(*c))
}

// FillFrom fills MessagesChatAdminsWithInvites from given interface.
func (c *MessagesChatAdminsWithInvites) FillFrom(from interface {
	GetAdmins() (value []ChatAdminWithInvites)
	GetUsers() (value []UserClass)
}) {
	c.Admins = from.GetAdmins()
	c.Users = from.GetUsers()
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*MessagesChatAdminsWithInvites) TypeID() uint32 {
	return MessagesChatAdminsWithInvitesTypeID
}

// TypeName returns name of type in TL schema.
func (*MessagesChatAdminsWithInvites) TypeName() string {
	return "messages.chatAdminsWithInvites"
}

// TypeInfo returns info about TL type.
func (c *MessagesChatAdminsWithInvites) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "messages.chatAdminsWithInvites",
		ID:   MessagesChatAdminsWithInvitesTypeID,
	}
	if c == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Admins",
			SchemaName: "admins",
		},
		{
			Name:       "Users",
			SchemaName: "users",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (c *MessagesChatAdminsWithInvites) Encode(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't encode messages.chatAdminsWithInvites#b69b72d7 as nil")
	}
	b.PutID(MessagesChatAdminsWithInvitesTypeID)
	return c.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (c *MessagesChatAdminsWithInvites) EncodeBare(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't encode messages.chatAdminsWithInvites#b69b72d7 as nil")
	}
	b.PutVectorHeader(len(c.Admins))
	for idx, v := range c.Admins {
		if err := v.Encode(b); err != nil {
			return fmt.Errorf("unable to encode messages.chatAdminsWithInvites#b69b72d7: field admins element with index %d: %w", idx, err)
		}
	}
	b.PutVectorHeader(len(c.Users))
	for idx, v := range c.Users {
		if v == nil {
			return fmt.Errorf("unable to encode messages.chatAdminsWithInvites#b69b72d7: field users element with index %d is nil", idx)
		}
		if err := v.Encode(b); err != nil {
			return fmt.Errorf("unable to encode messages.chatAdminsWithInvites#b69b72d7: field users element with index %d: %w", idx, err)
		}
	}
	return nil
}

// Decode implements bin.Decoder.
func (c *MessagesChatAdminsWithInvites) Decode(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't decode messages.chatAdminsWithInvites#b69b72d7 to nil")
	}
	if err := b.ConsumeID(MessagesChatAdminsWithInvitesTypeID); err != nil {
		return fmt.Errorf("unable to decode messages.chatAdminsWithInvites#b69b72d7: %w", err)
	}
	return c.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (c *MessagesChatAdminsWithInvites) DecodeBare(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't decode messages.chatAdminsWithInvites#b69b72d7 to nil")
	}
	{
		headerLen, err := b.VectorHeader()
		if err != nil {
			return fmt.Errorf("unable to decode messages.chatAdminsWithInvites#b69b72d7: field admins: %w", err)
		}

		if headerLen > 0 {
			c.Admins = make([]ChatAdminWithInvites, 0, headerLen%bin.PreallocateLimit)
		}
		for idx := 0; idx < headerLen; idx++ {
			var value ChatAdminWithInvites
			if err := value.Decode(b); err != nil {
				return fmt.Errorf("unable to decode messages.chatAdminsWithInvites#b69b72d7: field admins: %w", err)
			}
			c.Admins = append(c.Admins, value)
		}
	}
	{
		headerLen, err := b.VectorHeader()
		if err != nil {
			return fmt.Errorf("unable to decode messages.chatAdminsWithInvites#b69b72d7: field users: %w", err)
		}

		if headerLen > 0 {
			c.Users = make([]UserClass, 0, headerLen%bin.PreallocateLimit)
		}
		for idx := 0; idx < headerLen; idx++ {
			value, err := DecodeUser(b)
			if err != nil {
				return fmt.Errorf("unable to decode messages.chatAdminsWithInvites#b69b72d7: field users: %w", err)
			}
			c.Users = append(c.Users, value)
		}
	}
	return nil
}

// GetAdmins returns value of Admins field.
func (c *MessagesChatAdminsWithInvites) GetAdmins() (value []ChatAdminWithInvites) {
	if c == nil {
		return
	}
	return c.Admins
}

// GetUsers returns value of Users field.
func (c *MessagesChatAdminsWithInvites) GetUsers() (value []UserClass) {
	if c == nil {
		return
	}
	return c.Users
}

// MapUsers returns field Users wrapped in UserClassArray helper.
func (c *MessagesChatAdminsWithInvites) MapUsers() (value UserClassArray) {
	return UserClassArray(c.Users)
}
