// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// MessagesGetFavedStickersRequest represents TL type `messages.getFavedStickers#4f1aaa9`.
// Get faved stickers
//
// See https://core.telegram.org/method/messages.getFavedStickers for reference.
type MessagesGetFavedStickersRequest struct {
	// Hash for pagination, for more info click here¹
	//
	// Links:
	//  1) https://core.telegram.org/api/offsets#hash-generation
	Hash int64
}

// MessagesGetFavedStickersRequestTypeID is TL type id of MessagesGetFavedStickersRequest.
const MessagesGetFavedStickersRequestTypeID = 0x4f1aaa9

// Ensuring interfaces in compile-time for MessagesGetFavedStickersRequest.
var (
	_ bin.Encoder     = &MessagesGetFavedStickersRequest{}
	_ bin.Decoder     = &MessagesGetFavedStickersRequest{}
	_ bin.BareEncoder = &MessagesGetFavedStickersRequest{}
	_ bin.BareDecoder = &MessagesGetFavedStickersRequest{}
)

func (g *MessagesGetFavedStickersRequest) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.Hash == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *MessagesGetFavedStickersRequest) String() string {
	if g == nil {
		return "MessagesGetFavedStickersRequest(nil)"
	}
	type Alias MessagesGetFavedStickersRequest
	return fmt.Sprintf("MessagesGetFavedStickersRequest%+v", Alias(*g))
}

// FillFrom fills MessagesGetFavedStickersRequest from given interface.
func (g *MessagesGetFavedStickersRequest) FillFrom(from interface {
	GetHash() (value int64)
}) {
	g.Hash = from.GetHash()
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*MessagesGetFavedStickersRequest) TypeID() uint32 {
	return MessagesGetFavedStickersRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*MessagesGetFavedStickersRequest) TypeName() string {
	return "messages.getFavedStickers"
}

// TypeInfo returns info about TL type.
func (g *MessagesGetFavedStickersRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "messages.getFavedStickers",
		ID:   MessagesGetFavedStickersRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Hash",
			SchemaName: "hash",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *MessagesGetFavedStickersRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode messages.getFavedStickers#4f1aaa9 as nil")
	}
	b.PutID(MessagesGetFavedStickersRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *MessagesGetFavedStickersRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode messages.getFavedStickers#4f1aaa9 as nil")
	}
	b.PutLong(g.Hash)
	return nil
}

// Decode implements bin.Decoder.
func (g *MessagesGetFavedStickersRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode messages.getFavedStickers#4f1aaa9 to nil")
	}
	if err := b.ConsumeID(MessagesGetFavedStickersRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode messages.getFavedStickers#4f1aaa9: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *MessagesGetFavedStickersRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode messages.getFavedStickers#4f1aaa9 to nil")
	}
	{
		value, err := b.Long()
		if err != nil {
			return fmt.Errorf("unable to decode messages.getFavedStickers#4f1aaa9: field hash: %w", err)
		}
		g.Hash = value
	}
	return nil
}

// GetHash returns value of Hash field.
func (g *MessagesGetFavedStickersRequest) GetHash() (value int64) {
	if g == nil {
		return
	}
	return g.Hash
}

// MessagesGetFavedStickers invokes method messages.getFavedStickers#4f1aaa9 returning error if any.
// Get faved stickers
//
// See https://core.telegram.org/method/messages.getFavedStickers for reference.
func (c *Client) MessagesGetFavedStickers(ctx context.Context, hash int64) (MessagesFavedStickersClass, error) {
	var result MessagesFavedStickersBox

	request := &MessagesGetFavedStickersRequest{
		Hash: hash,
	}
	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return result.FavedStickers, nil
}
