// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// MessagesGetOnlinesRequest represents TL type `messages.getOnlines#6e2be050`.
// Get count of online users in a chat
//
// See https://core.telegram.org/method/messages.getOnlines for reference.
type MessagesGetOnlinesRequest struct {
	// The chat
	Peer InputPeerClass
}

// MessagesGetOnlinesRequestTypeID is TL type id of MessagesGetOnlinesRequest.
const MessagesGetOnlinesRequestTypeID = 0x6e2be050

// Ensuring interfaces in compile-time for MessagesGetOnlinesRequest.
var (
	_ bin.Encoder     = &MessagesGetOnlinesRequest{}
	_ bin.Decoder     = &MessagesGetOnlinesRequest{}
	_ bin.BareEncoder = &MessagesGetOnlinesRequest{}
	_ bin.BareDecoder = &MessagesGetOnlinesRequest{}
)

func (g *MessagesGetOnlinesRequest) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.Peer == nil) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *MessagesGetOnlinesRequest) String() string {
	if g == nil {
		return "MessagesGetOnlinesRequest(nil)"
	}
	type Alias MessagesGetOnlinesRequest
	return fmt.Sprintf("MessagesGetOnlinesRequest%+v", Alias(*g))
}

// FillFrom fills MessagesGetOnlinesRequest from given interface.
func (g *MessagesGetOnlinesRequest) FillFrom(from interface {
	GetPeer() (value InputPeerClass)
}) {
	g.Peer = from.GetPeer()
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*MessagesGetOnlinesRequest) TypeID() uint32 {
	return MessagesGetOnlinesRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*MessagesGetOnlinesRequest) TypeName() string {
	return "messages.getOnlines"
}

// TypeInfo returns info about TL type.
func (g *MessagesGetOnlinesRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "messages.getOnlines",
		ID:   MessagesGetOnlinesRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Peer",
			SchemaName: "peer",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *MessagesGetOnlinesRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode messages.getOnlines#6e2be050 as nil")
	}
	b.PutID(MessagesGetOnlinesRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *MessagesGetOnlinesRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode messages.getOnlines#6e2be050 as nil")
	}
	if g.Peer == nil {
		return fmt.Errorf("unable to encode messages.getOnlines#6e2be050: field peer is nil")
	}
	if err := g.Peer.Encode(b); err != nil {
		return fmt.Errorf("unable to encode messages.getOnlines#6e2be050: field peer: %w", err)
	}
	return nil
}

// Decode implements bin.Decoder.
func (g *MessagesGetOnlinesRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode messages.getOnlines#6e2be050 to nil")
	}
	if err := b.ConsumeID(MessagesGetOnlinesRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode messages.getOnlines#6e2be050: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *MessagesGetOnlinesRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode messages.getOnlines#6e2be050 to nil")
	}
	{
		value, err := DecodeInputPeer(b)
		if err != nil {
			return fmt.Errorf("unable to decode messages.getOnlines#6e2be050: field peer: %w", err)
		}
		g.Peer = value
	}
	return nil
}

// GetPeer returns value of Peer field.
func (g *MessagesGetOnlinesRequest) GetPeer() (value InputPeerClass) {
	if g == nil {
		return
	}
	return g.Peer
}

// MessagesGetOnlines invokes method messages.getOnlines#6e2be050 returning error if any.
// Get count of online users in a chat
//
// Possible errors:
//  400 CHANNEL_PRIVATE: You haven't joined this channel/supergroup.
//  400 PEER_ID_INVALID: The provided peer id is invalid.
//
// See https://core.telegram.org/method/messages.getOnlines for reference.
func (c *Client) MessagesGetOnlines(ctx context.Context, peer InputPeerClass) (*ChatOnlines, error) {
	var result ChatOnlines

	request := &MessagesGetOnlinesRequest{
		Peer: peer,
	}
	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
