// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// MessagesReadReactionsRequest represents TL type `messages.readReactions#82e251d7`.
//
// See https://core.telegram.org/method/messages.readReactions for reference.
type MessagesReadReactionsRequest struct {
	// Peer field of MessagesReadReactionsRequest.
	Peer InputPeerClass
}

// MessagesReadReactionsRequestTypeID is TL type id of MessagesReadReactionsRequest.
const MessagesReadReactionsRequestTypeID = 0x82e251d7

// Ensuring interfaces in compile-time for MessagesReadReactionsRequest.
var (
	_ bin.Encoder     = &MessagesReadReactionsRequest{}
	_ bin.Decoder     = &MessagesReadReactionsRequest{}
	_ bin.BareEncoder = &MessagesReadReactionsRequest{}
	_ bin.BareDecoder = &MessagesReadReactionsRequest{}
)

func (r *MessagesReadReactionsRequest) Zero() bool {
	if r == nil {
		return true
	}
	if !(r.Peer == nil) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (r *MessagesReadReactionsRequest) String() string {
	if r == nil {
		return "MessagesReadReactionsRequest(nil)"
	}
	type Alias MessagesReadReactionsRequest
	return fmt.Sprintf("MessagesReadReactionsRequest%+v", Alias(*r))
}

// FillFrom fills MessagesReadReactionsRequest from given interface.
func (r *MessagesReadReactionsRequest) FillFrom(from interface {
	GetPeer() (value InputPeerClass)
}) {
	r.Peer = from.GetPeer()
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*MessagesReadReactionsRequest) TypeID() uint32 {
	return MessagesReadReactionsRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*MessagesReadReactionsRequest) TypeName() string {
	return "messages.readReactions"
}

// TypeInfo returns info about TL type.
func (r *MessagesReadReactionsRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "messages.readReactions",
		ID:   MessagesReadReactionsRequestTypeID,
	}
	if r == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Peer",
			SchemaName: "peer",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (r *MessagesReadReactionsRequest) Encode(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't encode messages.readReactions#82e251d7 as nil")
	}
	b.PutID(MessagesReadReactionsRequestTypeID)
	return r.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (r *MessagesReadReactionsRequest) EncodeBare(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't encode messages.readReactions#82e251d7 as nil")
	}
	if r.Peer == nil {
		return fmt.Errorf("unable to encode messages.readReactions#82e251d7: field peer is nil")
	}
	if err := r.Peer.Encode(b); err != nil {
		return fmt.Errorf("unable to encode messages.readReactions#82e251d7: field peer: %w", err)
	}
	return nil
}

// Decode implements bin.Decoder.
func (r *MessagesReadReactionsRequest) Decode(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't decode messages.readReactions#82e251d7 to nil")
	}
	if err := b.ConsumeID(MessagesReadReactionsRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode messages.readReactions#82e251d7: %w", err)
	}
	return r.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (r *MessagesReadReactionsRequest) DecodeBare(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't decode messages.readReactions#82e251d7 to nil")
	}
	{
		value, err := DecodeInputPeer(b)
		if err != nil {
			return fmt.Errorf("unable to decode messages.readReactions#82e251d7: field peer: %w", err)
		}
		r.Peer = value
	}
	return nil
}

// GetPeer returns value of Peer field.
func (r *MessagesReadReactionsRequest) GetPeer() (value InputPeerClass) {
	if r == nil {
		return
	}
	return r.Peer
}

// MessagesReadReactions invokes method messages.readReactions#82e251d7 returning error if any.
//
// See https://core.telegram.org/method/messages.readReactions for reference.
func (c *Client) MessagesReadReactions(ctx context.Context, peer InputPeerClass) (*MessagesAffectedHistory, error) {
	var result MessagesAffectedHistory

	request := &MessagesReadReactionsRequest{
		Peer: peer,
	}
	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
