// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// MessagesSearchSentMediaRequest represents TL type `messages.searchSentMedia#107e31a0`.
//
// See https://core.telegram.org/method/messages.searchSentMedia for reference.
type MessagesSearchSentMediaRequest struct {
	// Q field of MessagesSearchSentMediaRequest.
	Q string
	// Filter field of MessagesSearchSentMediaRequest.
	Filter MessagesFilterClass
	// Limit field of MessagesSearchSentMediaRequest.
	Limit int
}

// MessagesSearchSentMediaRequestTypeID is TL type id of MessagesSearchSentMediaRequest.
const MessagesSearchSentMediaRequestTypeID = 0x107e31a0

// Ensuring interfaces in compile-time for MessagesSearchSentMediaRequest.
var (
	_ bin.Encoder     = &MessagesSearchSentMediaRequest{}
	_ bin.Decoder     = &MessagesSearchSentMediaRequest{}
	_ bin.BareEncoder = &MessagesSearchSentMediaRequest{}
	_ bin.BareDecoder = &MessagesSearchSentMediaRequest{}
)

func (s *MessagesSearchSentMediaRequest) Zero() bool {
	if s == nil {
		return true
	}
	if !(s.Q == "") {
		return false
	}
	if !(s.Filter == nil) {
		return false
	}
	if !(s.Limit == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (s *MessagesSearchSentMediaRequest) String() string {
	if s == nil {
		return "MessagesSearchSentMediaRequest(nil)"
	}
	type Alias MessagesSearchSentMediaRequest
	return fmt.Sprintf("MessagesSearchSentMediaRequest%+v", Alias(*s))
}

// FillFrom fills MessagesSearchSentMediaRequest from given interface.
func (s *MessagesSearchSentMediaRequest) FillFrom(from interface {
	GetQ() (value string)
	GetFilter() (value MessagesFilterClass)
	GetLimit() (value int)
}) {
	s.Q = from.GetQ()
	s.Filter = from.GetFilter()
	s.Limit = from.GetLimit()
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*MessagesSearchSentMediaRequest) TypeID() uint32 {
	return MessagesSearchSentMediaRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*MessagesSearchSentMediaRequest) TypeName() string {
	return "messages.searchSentMedia"
}

// TypeInfo returns info about TL type.
func (s *MessagesSearchSentMediaRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "messages.searchSentMedia",
		ID:   MessagesSearchSentMediaRequestTypeID,
	}
	if s == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Q",
			SchemaName: "q",
		},
		{
			Name:       "Filter",
			SchemaName: "filter",
		},
		{
			Name:       "Limit",
			SchemaName: "limit",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (s *MessagesSearchSentMediaRequest) Encode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode messages.searchSentMedia#107e31a0 as nil")
	}
	b.PutID(MessagesSearchSentMediaRequestTypeID)
	return s.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (s *MessagesSearchSentMediaRequest) EncodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode messages.searchSentMedia#107e31a0 as nil")
	}
	b.PutString(s.Q)
	if s.Filter == nil {
		return fmt.Errorf("unable to encode messages.searchSentMedia#107e31a0: field filter is nil")
	}
	if err := s.Filter.Encode(b); err != nil {
		return fmt.Errorf("unable to encode messages.searchSentMedia#107e31a0: field filter: %w", err)
	}
	b.PutInt(s.Limit)
	return nil
}

// Decode implements bin.Decoder.
func (s *MessagesSearchSentMediaRequest) Decode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode messages.searchSentMedia#107e31a0 to nil")
	}
	if err := b.ConsumeID(MessagesSearchSentMediaRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode messages.searchSentMedia#107e31a0: %w", err)
	}
	return s.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (s *MessagesSearchSentMediaRequest) DecodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode messages.searchSentMedia#107e31a0 to nil")
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode messages.searchSentMedia#107e31a0: field q: %w", err)
		}
		s.Q = value
	}
	{
		value, err := DecodeMessagesFilter(b)
		if err != nil {
			return fmt.Errorf("unable to decode messages.searchSentMedia#107e31a0: field filter: %w", err)
		}
		s.Filter = value
	}
	{
		value, err := b.Int()
		if err != nil {
			return fmt.Errorf("unable to decode messages.searchSentMedia#107e31a0: field limit: %w", err)
		}
		s.Limit = value
	}
	return nil
}

// GetQ returns value of Q field.
func (s *MessagesSearchSentMediaRequest) GetQ() (value string) {
	if s == nil {
		return
	}
	return s.Q
}

// GetFilter returns value of Filter field.
func (s *MessagesSearchSentMediaRequest) GetFilter() (value MessagesFilterClass) {
	if s == nil {
		return
	}
	return s.Filter
}

// GetLimit returns value of Limit field.
func (s *MessagesSearchSentMediaRequest) GetLimit() (value int) {
	if s == nil {
		return
	}
	return s.Limit
}

// MessagesSearchSentMedia invokes method messages.searchSentMedia#107e31a0 returning error if any.
//
// See https://core.telegram.org/method/messages.searchSentMedia for reference.
func (c *Client) MessagesSearchSentMedia(ctx context.Context, request *MessagesSearchSentMediaRequest) (MessagesMessagesClass, error) {
	var result MessagesMessagesBox

	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return result.Messages, nil
}
