// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// MessagesSendReactionRequest represents TL type `messages.sendReaction#25690ce4`.
//
// See https://core.telegram.org/method/messages.sendReaction for reference.
type MessagesSendReactionRequest struct {
	// Flags field of MessagesSendReactionRequest.
	Flags bin.Fields
	// Big field of MessagesSendReactionRequest.
	Big bool
	// Peer field of MessagesSendReactionRequest.
	Peer InputPeerClass
	// MsgID field of MessagesSendReactionRequest.
	MsgID int
	// Reaction field of MessagesSendReactionRequest.
	//
	// Use SetReaction and GetReaction helpers.
	Reaction string
}

// MessagesSendReactionRequestTypeID is TL type id of MessagesSendReactionRequest.
const MessagesSendReactionRequestTypeID = 0x25690ce4

// Ensuring interfaces in compile-time for MessagesSendReactionRequest.
var (
	_ bin.Encoder     = &MessagesSendReactionRequest{}
	_ bin.Decoder     = &MessagesSendReactionRequest{}
	_ bin.BareEncoder = &MessagesSendReactionRequest{}
	_ bin.BareDecoder = &MessagesSendReactionRequest{}
)

func (s *MessagesSendReactionRequest) Zero() bool {
	if s == nil {
		return true
	}
	if !(s.Flags.Zero()) {
		return false
	}
	if !(s.Big == false) {
		return false
	}
	if !(s.Peer == nil) {
		return false
	}
	if !(s.MsgID == 0) {
		return false
	}
	if !(s.Reaction == "") {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (s *MessagesSendReactionRequest) String() string {
	if s == nil {
		return "MessagesSendReactionRequest(nil)"
	}
	type Alias MessagesSendReactionRequest
	return fmt.Sprintf("MessagesSendReactionRequest%+v", Alias(*s))
}

// FillFrom fills MessagesSendReactionRequest from given interface.
func (s *MessagesSendReactionRequest) FillFrom(from interface {
	GetBig() (value bool)
	GetPeer() (value InputPeerClass)
	GetMsgID() (value int)
	GetReaction() (value string, ok bool)
}) {
	s.Big = from.GetBig()
	s.Peer = from.GetPeer()
	s.MsgID = from.GetMsgID()
	if val, ok := from.GetReaction(); ok {
		s.Reaction = val
	}

}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*MessagesSendReactionRequest) TypeID() uint32 {
	return MessagesSendReactionRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*MessagesSendReactionRequest) TypeName() string {
	return "messages.sendReaction"
}

// TypeInfo returns info about TL type.
func (s *MessagesSendReactionRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "messages.sendReaction",
		ID:   MessagesSendReactionRequestTypeID,
	}
	if s == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Big",
			SchemaName: "big",
			Null:       !s.Flags.Has(1),
		},
		{
			Name:       "Peer",
			SchemaName: "peer",
		},
		{
			Name:       "MsgID",
			SchemaName: "msg_id",
		},
		{
			Name:       "Reaction",
			SchemaName: "reaction",
			Null:       !s.Flags.Has(0),
		},
	}
	return typ
}

// SetFlags sets flags for non-zero fields.
func (s *MessagesSendReactionRequest) SetFlags() {
	if !(s.Big == false) {
		s.Flags.Set(1)
	}
	if !(s.Reaction == "") {
		s.Flags.Set(0)
	}
}

// Encode implements bin.Encoder.
func (s *MessagesSendReactionRequest) Encode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode messages.sendReaction#25690ce4 as nil")
	}
	b.PutID(MessagesSendReactionRequestTypeID)
	return s.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (s *MessagesSendReactionRequest) EncodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode messages.sendReaction#25690ce4 as nil")
	}
	s.SetFlags()
	if err := s.Flags.Encode(b); err != nil {
		return fmt.Errorf("unable to encode messages.sendReaction#25690ce4: field flags: %w", err)
	}
	if s.Peer == nil {
		return fmt.Errorf("unable to encode messages.sendReaction#25690ce4: field peer is nil")
	}
	if err := s.Peer.Encode(b); err != nil {
		return fmt.Errorf("unable to encode messages.sendReaction#25690ce4: field peer: %w", err)
	}
	b.PutInt(s.MsgID)
	if s.Flags.Has(0) {
		b.PutString(s.Reaction)
	}
	return nil
}

// Decode implements bin.Decoder.
func (s *MessagesSendReactionRequest) Decode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode messages.sendReaction#25690ce4 to nil")
	}
	if err := b.ConsumeID(MessagesSendReactionRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode messages.sendReaction#25690ce4: %w", err)
	}
	return s.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (s *MessagesSendReactionRequest) DecodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode messages.sendReaction#25690ce4 to nil")
	}
	{
		if err := s.Flags.Decode(b); err != nil {
			return fmt.Errorf("unable to decode messages.sendReaction#25690ce4: field flags: %w", err)
		}
	}
	s.Big = s.Flags.Has(1)
	{
		value, err := DecodeInputPeer(b)
		if err != nil {
			return fmt.Errorf("unable to decode messages.sendReaction#25690ce4: field peer: %w", err)
		}
		s.Peer = value
	}
	{
		value, err := b.Int()
		if err != nil {
			return fmt.Errorf("unable to decode messages.sendReaction#25690ce4: field msg_id: %w", err)
		}
		s.MsgID = value
	}
	if s.Flags.Has(0) {
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode messages.sendReaction#25690ce4: field reaction: %w", err)
		}
		s.Reaction = value
	}
	return nil
}

// SetBig sets value of Big conditional field.
func (s *MessagesSendReactionRequest) SetBig(value bool) {
	if value {
		s.Flags.Set(1)
		s.Big = true
	} else {
		s.Flags.Unset(1)
		s.Big = false
	}
}

// GetBig returns value of Big conditional field.
func (s *MessagesSendReactionRequest) GetBig() (value bool) {
	if s == nil {
		return
	}
	return s.Flags.Has(1)
}

// GetPeer returns value of Peer field.
func (s *MessagesSendReactionRequest) GetPeer() (value InputPeerClass) {
	if s == nil {
		return
	}
	return s.Peer
}

// GetMsgID returns value of MsgID field.
func (s *MessagesSendReactionRequest) GetMsgID() (value int) {
	if s == nil {
		return
	}
	return s.MsgID
}

// SetReaction sets value of Reaction conditional field.
func (s *MessagesSendReactionRequest) SetReaction(value string) {
	s.Flags.Set(0)
	s.Reaction = value
}

// GetReaction returns value of Reaction conditional field and
// boolean which is true if field was set.
func (s *MessagesSendReactionRequest) GetReaction() (value string, ok bool) {
	if s == nil {
		return
	}
	if !s.Flags.Has(0) {
		return value, false
	}
	return s.Reaction, true
}

// MessagesSendReaction invokes method messages.sendReaction#25690ce4 returning error if any.
//
// See https://core.telegram.org/method/messages.sendReaction for reference.
func (c *Client) MessagesSendReaction(ctx context.Context, request *MessagesSendReactionRequest) (UpdatesClass, error) {
	var result UpdatesBox

	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return result.Updates, nil
}
