// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// ReactionCount represents TL type `reactionCount#6fb250d1`.
//
// See https://core.telegram.org/constructor/reactionCount for reference.
type ReactionCount struct {
	// Flags field of ReactionCount.
	Flags bin.Fields
	// Chosen field of ReactionCount.
	Chosen bool
	// Reaction field of ReactionCount.
	Reaction string
	// Count field of ReactionCount.
	Count int
}

// ReactionCountTypeID is TL type id of ReactionCount.
const ReactionCountTypeID = 0x6fb250d1

// Ensuring interfaces in compile-time for ReactionCount.
var (
	_ bin.Encoder     = &ReactionCount{}
	_ bin.Decoder     = &ReactionCount{}
	_ bin.BareEncoder = &ReactionCount{}
	_ bin.BareDecoder = &ReactionCount{}
)

func (r *ReactionCount) Zero() bool {
	if r == nil {
		return true
	}
	if !(r.Flags.Zero()) {
		return false
	}
	if !(r.Chosen == false) {
		return false
	}
	if !(r.Reaction == "") {
		return false
	}
	if !(r.Count == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (r *ReactionCount) String() string {
	if r == nil {
		return "ReactionCount(nil)"
	}
	type Alias ReactionCount
	return fmt.Sprintf("ReactionCount%+v", Alias(*r))
}

// FillFrom fills ReactionCount from given interface.
func (r *ReactionCount) FillFrom(from interface {
	GetChosen() (value bool)
	GetReaction() (value string)
	GetCount() (value int)
}) {
	r.Chosen = from.GetChosen()
	r.Reaction = from.GetReaction()
	r.Count = from.GetCount()
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*ReactionCount) TypeID() uint32 {
	return ReactionCountTypeID
}

// TypeName returns name of type in TL schema.
func (*ReactionCount) TypeName() string {
	return "reactionCount"
}

// TypeInfo returns info about TL type.
func (r *ReactionCount) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "reactionCount",
		ID:   ReactionCountTypeID,
	}
	if r == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Chosen",
			SchemaName: "chosen",
			Null:       !r.Flags.Has(0),
		},
		{
			Name:       "Reaction",
			SchemaName: "reaction",
		},
		{
			Name:       "Count",
			SchemaName: "count",
		},
	}
	return typ
}

// SetFlags sets flags for non-zero fields.
func (r *ReactionCount) SetFlags() {
	if !(r.Chosen == false) {
		r.Flags.Set(0)
	}
}

// Encode implements bin.Encoder.
func (r *ReactionCount) Encode(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't encode reactionCount#6fb250d1 as nil")
	}
	b.PutID(ReactionCountTypeID)
	return r.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (r *ReactionCount) EncodeBare(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't encode reactionCount#6fb250d1 as nil")
	}
	r.SetFlags()
	if err := r.Flags.Encode(b); err != nil {
		return fmt.Errorf("unable to encode reactionCount#6fb250d1: field flags: %w", err)
	}
	b.PutString(r.Reaction)
	b.PutInt(r.Count)
	return nil
}

// Decode implements bin.Decoder.
func (r *ReactionCount) Decode(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't decode reactionCount#6fb250d1 to nil")
	}
	if err := b.ConsumeID(ReactionCountTypeID); err != nil {
		return fmt.Errorf("unable to decode reactionCount#6fb250d1: %w", err)
	}
	return r.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (r *ReactionCount) DecodeBare(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't decode reactionCount#6fb250d1 to nil")
	}
	{
		if err := r.Flags.Decode(b); err != nil {
			return fmt.Errorf("unable to decode reactionCount#6fb250d1: field flags: %w", err)
		}
	}
	r.Chosen = r.Flags.Has(0)
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode reactionCount#6fb250d1: field reaction: %w", err)
		}
		r.Reaction = value
	}
	{
		value, err := b.Int()
		if err != nil {
			return fmt.Errorf("unable to decode reactionCount#6fb250d1: field count: %w", err)
		}
		r.Count = value
	}
	return nil
}

// SetChosen sets value of Chosen conditional field.
func (r *ReactionCount) SetChosen(value bool) {
	if value {
		r.Flags.Set(0)
		r.Chosen = true
	} else {
		r.Flags.Unset(0)
		r.Chosen = false
	}
}

// GetChosen returns value of Chosen conditional field.
func (r *ReactionCount) GetChosen() (value bool) {
	if r == nil {
		return
	}
	return r.Flags.Has(0)
}

// GetReaction returns value of Reaction field.
func (r *ReactionCount) GetReaction() (value string) {
	if r == nil {
		return
	}
	return r.Reaction
}

// GetCount returns value of Count field.
func (r *ReactionCount) GetCount() (value int) {
	if r == nil {
		return
	}
	return r.Count
}
