//go:build !no_gotd_slices
// +build !no_gotd_slices

// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// UserClassArray is adapter for slice of UserClass.
type UserClassArray []UserClass

// Sort sorts slice of UserClass.
func (s UserClassArray) Sort(less func(a, b UserClass) bool) UserClassArray {
	sort.Slice(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// SortStable sorts slice of UserClass.
func (s UserClassArray) SortStable(less func(a, b UserClass) bool) UserClassArray {
	sort.SliceStable(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// Retain filters in-place slice of UserClass.
func (s UserClassArray) Retain(keep func(x UserClass) bool) UserClassArray {
	n := 0
	for _, x := range s {
		if keep(x) {
			s[n] = x
			n++
		}
	}
	s = s[:n]

	return s
}

// First returns first element of slice (if exists).
func (s UserClassArray) First() (v UserClass, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[0], true
}

// Last returns last element of slice (if exists).
func (s UserClassArray) Last() (v UserClass, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[len(s)-1], true
}

// PopFirst returns first element of slice (if exists) and deletes it.
func (s *UserClassArray) PopFirst() (v UserClass, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[0]

	// Delete by index from SliceTricks.
	copy(a[0:], a[1:])
	var zero UserClass
	a[len(a)-1] = zero
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// Pop returns last element of slice (if exists) and deletes it.
func (s *UserClassArray) Pop() (v UserClass, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[len(a)-1]
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// SortByID sorts slice of UserClass by ID.
func (s UserClassArray) SortByID() UserClassArray {
	return s.Sort(func(a, b UserClass) bool {
		return a.GetID() < b.GetID()
	})
}

// SortStableByID sorts slice of UserClass by ID.
func (s UserClassArray) SortStableByID() UserClassArray {
	return s.SortStable(func(a, b UserClass) bool {
		return a.GetID() < b.GetID()
	})
}

// FillUserEmptyMap fills only UserEmpty constructors to given map.
func (s UserClassArray) FillUserEmptyMap(to map[int64]*UserEmpty) {
	for _, elem := range s {
		value, ok := elem.(*UserEmpty)
		if !ok {
			continue
		}
		to[value.GetID()] = value
	}
}

// UserEmptyToMap collects only UserEmpty constructors to map.
func (s UserClassArray) UserEmptyToMap() map[int64]*UserEmpty {
	r := make(map[int64]*UserEmpty, len(s))
	s.FillUserEmptyMap(r)
	return r
}

// AsUserEmpty returns copy with only UserEmpty constructors.
func (s UserClassArray) AsUserEmpty() (to UserEmptyArray) {
	for _, elem := range s {
		value, ok := elem.(*UserEmpty)
		if !ok {
			continue
		}
		to = append(to, *value)
	}

	return to
}

// FillUserMap fills only User constructors to given map.
func (s UserClassArray) FillUserMap(to map[int64]*User) {
	for _, elem := range s {
		value, ok := elem.(*User)
		if !ok {
			continue
		}
		to[value.GetID()] = value
	}
}

// UserToMap collects only User constructors to map.
func (s UserClassArray) UserToMap() map[int64]*User {
	r := make(map[int64]*User, len(s))
	s.FillUserMap(r)
	return r
}

// AsUser returns copy with only User constructors.
func (s UserClassArray) AsUser() (to UserArray) {
	for _, elem := range s {
		value, ok := elem.(*User)
		if !ok {
			continue
		}
		to = append(to, *value)
	}

	return to
}

// FillNotEmptyMap fills only NotEmpty constructors to given map.
func (s UserClassArray) FillNotEmptyMap(to map[int64]*User) {
	for _, elem := range s {
		value, ok := elem.AsNotEmpty()
		if !ok {
			continue
		}
		to[value.GetID()] = value
	}
}

// NotEmptyToMap collects only NotEmpty constructors to map.
func (s UserClassArray) NotEmptyToMap() map[int64]*User {
	r := make(map[int64]*User, len(s))
	s.FillNotEmptyMap(r)
	return r
}

// AppendOnlyNotEmpty appends only NotEmpty constructors to
// given slice.
func (s UserClassArray) AppendOnlyNotEmpty(to []*User) []*User {
	for _, elem := range s {
		value, ok := elem.AsNotEmpty()
		if !ok {
			continue
		}
		to = append(to, value)
	}

	return to
}

// AsNotEmpty returns copy with only NotEmpty constructors.
func (s UserClassArray) AsNotEmpty() (to []*User) {
	return s.AppendOnlyNotEmpty(to)
}

// FirstAsNotEmpty returns first element of slice (if exists).
func (s UserClassArray) FirstAsNotEmpty() (v *User, ok bool) {
	value, ok := s.First()
	if !ok {
		return
	}
	return value.AsNotEmpty()
}

// LastAsNotEmpty returns last element of slice (if exists).
func (s UserClassArray) LastAsNotEmpty() (v *User, ok bool) {
	value, ok := s.Last()
	if !ok {
		return
	}
	return value.AsNotEmpty()
}

// PopFirstAsNotEmpty returns element of slice (if exists).
func (s *UserClassArray) PopFirstAsNotEmpty() (v *User, ok bool) {
	value, ok := s.PopFirst()
	if !ok {
		return
	}
	return value.AsNotEmpty()
}

// PopAsNotEmpty returns element of slice (if exists).
func (s *UserClassArray) PopAsNotEmpty() (v *User, ok bool) {
	value, ok := s.Pop()
	if !ok {
		return
	}
	return value.AsNotEmpty()
}

// UserEmptyArray is adapter for slice of UserEmpty.
type UserEmptyArray []UserEmpty

// Sort sorts slice of UserEmpty.
func (s UserEmptyArray) Sort(less func(a, b UserEmpty) bool) UserEmptyArray {
	sort.Slice(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// SortStable sorts slice of UserEmpty.
func (s UserEmptyArray) SortStable(less func(a, b UserEmpty) bool) UserEmptyArray {
	sort.SliceStable(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// Retain filters in-place slice of UserEmpty.
func (s UserEmptyArray) Retain(keep func(x UserEmpty) bool) UserEmptyArray {
	n := 0
	for _, x := range s {
		if keep(x) {
			s[n] = x
			n++
		}
	}
	s = s[:n]

	return s
}

// First returns first element of slice (if exists).
func (s UserEmptyArray) First() (v UserEmpty, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[0], true
}

// Last returns last element of slice (if exists).
func (s UserEmptyArray) Last() (v UserEmpty, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[len(s)-1], true
}

// PopFirst returns first element of slice (if exists) and deletes it.
func (s *UserEmptyArray) PopFirst() (v UserEmpty, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[0]

	// Delete by index from SliceTricks.
	copy(a[0:], a[1:])
	var zero UserEmpty
	a[len(a)-1] = zero
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// Pop returns last element of slice (if exists) and deletes it.
func (s *UserEmptyArray) Pop() (v UserEmpty, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[len(a)-1]
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// SortByID sorts slice of UserEmpty by ID.
func (s UserEmptyArray) SortByID() UserEmptyArray {
	return s.Sort(func(a, b UserEmpty) bool {
		return a.GetID() < b.GetID()
	})
}

// SortStableByID sorts slice of UserEmpty by ID.
func (s UserEmptyArray) SortStableByID() UserEmptyArray {
	return s.SortStable(func(a, b UserEmpty) bool {
		return a.GetID() < b.GetID()
	})
}

// FillMap fills constructors to given map.
func (s UserEmptyArray) FillMap(to map[int64]UserEmpty) {
	for _, value := range s {
		to[value.GetID()] = value
	}
}

// ToMap collects constructors to map.
func (s UserEmptyArray) ToMap() map[int64]UserEmpty {
	r := make(map[int64]UserEmpty, len(s))
	s.FillMap(r)
	return r
}

// UserArray is adapter for slice of User.
type UserArray []User

// Sort sorts slice of User.
func (s UserArray) Sort(less func(a, b User) bool) UserArray {
	sort.Slice(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// SortStable sorts slice of User.
func (s UserArray) SortStable(less func(a, b User) bool) UserArray {
	sort.SliceStable(s, func(i, j int) bool {
		return less(s[i], s[j])
	})
	return s
}

// Retain filters in-place slice of User.
func (s UserArray) Retain(keep func(x User) bool) UserArray {
	n := 0
	for _, x := range s {
		if keep(x) {
			s[n] = x
			n++
		}
	}
	s = s[:n]

	return s
}

// First returns first element of slice (if exists).
func (s UserArray) First() (v User, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[0], true
}

// Last returns last element of slice (if exists).
func (s UserArray) Last() (v User, ok bool) {
	if len(s) < 1 {
		return
	}
	return s[len(s)-1], true
}

// PopFirst returns first element of slice (if exists) and deletes it.
func (s *UserArray) PopFirst() (v User, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[0]

	// Delete by index from SliceTricks.
	copy(a[0:], a[1:])
	var zero User
	a[len(a)-1] = zero
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// Pop returns last element of slice (if exists) and deletes it.
func (s *UserArray) Pop() (v User, ok bool) {
	if s == nil || len(*s) < 1 {
		return
	}

	a := *s
	v = a[len(a)-1]
	a = a[:len(a)-1]
	*s = a

	return v, true
}

// SortByID sorts slice of User by ID.
func (s UserArray) SortByID() UserArray {
	return s.Sort(func(a, b User) bool {
		return a.GetID() < b.GetID()
	})
}

// SortStableByID sorts slice of User by ID.
func (s UserArray) SortStableByID() UserArray {
	return s.SortStable(func(a, b User) bool {
		return a.GetID() < b.GetID()
	})
}

// FillMap fills constructors to given map.
func (s UserArray) FillMap(to map[int64]User) {
	for _, value := range s {
		to[value.GetID()] = value
	}
}

// ToMap collects constructors to map.
func (s UserArray) ToMap() map[int64]User {
	r := make(map[int64]User, len(s))
	s.FillMap(r)
	return r
}
